Package: optimizeR
Title: Unified Framework for Numerical Optimizers
Version: 1.3.0
Authors@R: c(
    person("Lennart", "Oelschl\u00e4ger", 
           email = "oelschlaeger.lennart@gmail.com", 
           role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-5421-9313")),
    person("Marius", "\u00d6tting", 
           email = "marius.oetting@uni-bielefeld.de", 
           role = c("ctb"),
           comment = c(ORCID = "0000-0002-9373-0365"))
           )
Description: Provides a unified object-oriented framework for numerical
    optimizers in R. Supports minimization and maximization with any optimizer,
    optimization over more than one function argument, computation time
    measurement, and time limits for long optimization tasks.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.3
Depends: R (>= 4.0.0)
Imports: checkmate, cli, lbfgsb3c, numDeriv, oeli (>= 0.7.2), pracma,
        R6, stats, TestFunctions, ucminf
Suggests: datasets, ggplot2, rmarkdown, testthat
Config/testthat/edition: 3
URL: https://loelschlaeger.de/optimizeR/
BugReports: https://github.com/loelschlaeger/optimizeR/issues
NeedsCompilation: no
Packaged: 2026-05-07 15:40:47 UTC; Lennart Oelschläger
Author: Lennart Oelschläger [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5421-9313>),
  Marius Ötting [ctb] (ORCID: <https://orcid.org/0000-0002-9373-0365>)
Maintainer: Lennart Oelschläger <oelschlaeger.lennart@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-09 14:41:52 UTC
Built: R 4.4.3; ; 2026-05-09 16:27:31 UTC; unix

Package: optimizeR
Title: Unified Framework for Numerical Optimizers
Version: 1.3.0
Authors@R: c(
    person("Lennart", "Oelschl\u00e4ger", 
           email = "oelschlaeger.lennart@gmail.com", 
           role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-5421-9313")),
    person("Marius", "\u00d6tting", 
           email = "marius.oetting@uni-bielefeld.de", 
           role = c("ctb"),
           comment = c(ORCID = "0000-0002-9373-0365"))
           )
Description: Provides a unified object-oriented framework for numerical
    optimizers in R. Supports minimization and maximization with any optimizer,
    optimization over more than one function argument, computation time
    measurement, and time limits for long optimization tasks.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.3
Depends: R (>= 4.0.0)
Imports: checkmate, cli, lbfgsb3c, numDeriv, oeli (>= 0.7.2), pracma,
        R6, stats, TestFunctions, ucminf
Suggests: datasets, ggplot2, rmarkdown, testthat
Config/testthat/edition: 3
URL: https://loelschlaeger.de/optimizeR/
BugReports: https://github.com/loelschlaeger/optimizeR/issues
NeedsCompilation: no
Packaged: 2026-05-07 15:40:47 UTC; Lennart Oelschläger
Author: Lennart Oelschläger [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5421-9313>),
  Marius Ötting [ctb] (ORCID: <https://orcid.org/0000-0002-9373-0365>)
Maintainer: Lennart Oelschläger <oelschlaeger.lennart@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-09 14:41:52 UTC
Built: R 4.5.2; ; 2026-05-09 17:15:00 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# optimizeR <img src="man/figures/logo.png" align="right" height="139" />

<!-- badges: start -->

[![CRAN
status](https://www.r-pkg.org/badges/version/optimizeR)](https://CRAN.R-project.org/package=optimizeR)
[![metacran
downloads](https://cranlogs.r-pkg.org/badges/last-month/optimizeR)](https://cran.r-project.org/package=optimizeR)
[![R-CMD-check](https://github.com/loelschlaeger/optimizeR/workflows/R-CMD-check/badge.svg)](https://github.com/loelschlaeger/optimizeR/actions)
[![Codecov test
coverage](https://codecov.io/gh/loelschlaeger/optimizeR/graph/badge.svg)](https://app.codecov.io/gh/loelschlaeger/optimizeR)
<!-- badges: end -->

The `{optimizeR}` package provides an object-oriented framework for
optimizer functions in R and adds convenience features for minimization
and maximization.

**You probably do not need this package if you…**

- already know which optimizer you want to use and are comfortable with
  its constraints, such as minimization only over the first function
  argument;
- want to compare optimizers that are already covered by
  [`{optimx}`](https://CRAN.R-project.org/package=optimx), a framework
  for comparing about 30 optimizers;
- are searching for new optimization algorithms, because this package
  does not implement optimizer functions itself.

**You might find the package useful if you want to…**

- compare optimizer functions not covered by `{optimx}` or other
  frameworks (see the [CRAN Task View: Optimization and Mathematical
  Programming](https://CRAN.R-project.org/view=Optimization) for an
  overview);
- have consistently named inputs and outputs across different
  optimizers;
- view optimizers as objects, which can help when implementing packages
  that depend on optimization;
- use optimizers for both minimization and maximization,
- optimize over more than one function argument,
- measure computation time or set a time limit for long optimization
  tasks.

## How to use the package?

The following demo is a bit artificial, but it showcases the package
purpose. Assume we want to

- maximize a function over two of its arguments,
- interrupt optimization if it exceeds 10 seconds,
- compare the performance of `stats::nlm` and `pracma::nelder_mead`.

We can do this task with `{optimizeR}`. You can install the released
package version from [CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("optimizeR")
```

Then load the package via `library("optimizeR")`.

**1. Define the objective function**

Let $f:\mathbb{R}^4\to\mathbb{R}$ with

``` r
f <- function(a, b, x, y) {
  a * exp(-0.2 * sqrt(0.5 * (x^2 + y^2))) + exp(0.5 * (cos(2 * pi * x) + cos(2 * pi * y))) - exp(1) - b
}
```

For `a = b = 20`, this is the negative [Ackley
function](https://en.wikipedia.org/wiki/Ackley_function) with a global
maximum in `x = y = 0`:

<img src="man/figures/README-plot-ackley-1.png" alt="" width="50%" style="display: block; margin: auto;" />

We want to keep `a` and `b` fixed here and optimize over `x` and `y`,
which are both single numeric values.

Two problems would occur if we optimized `f` directly with, say,
`stats::nlm`:

1.  There are two target arguments (`x` and `y`).
2.  The target arguments are not the first arguments of `f`.

Both features are unsupported by `stats::nlm` and most other optimizers,
but they are supported by `{optimizeR}`. We just have to define an
objective object that we can later pass to the optimizers:

``` r
objective <- Objective$new(
  f = f,                 # f is our objective function
  target = c("x", "y"),  # x and y are the target arguments
  npar = c(1, 1),        # the target arguments have both a length of 1
  "a" = 20,              
  "b" = 20               # a and b have fixed values
)
```

**2. Create the optimizer objects**

Now that we have defined the objective function, let’s define the
optimizer objects. For `stats::nlm`, this is a one-liner:

``` r
nlm <- Optimizer$new(which = "stats::nlm")
```

The `{optimizeR}` package provides a dictionary of optimizers that can
be selected directly via the `which` argument. For an overview of
available optimizers, see:

``` r
optimizer_dictionary
#> <Dictionary> optimization algorithms 
#> Keys: 
#> - lbfgsb3c::lbfgsb3c
#> - lbfgsb3c::lbfgsb3
#> - lbfgsb3c::lbfgsb3f
#> - lbfgsb3c::lbfgsb3x
#> - stats::nlm
#> - stats::nlminb
#> - stats::optim
#> - ucminf::ucminf
```

Any optimizer that is not contained in the dictionary can still be put
into the `{optimizeR}` framework by setting `which = "custom"` first:

``` r
nelder_mead <- Optimizer$new(which = "custom")
#> Use method `$definition()` next to define a custom optimizer.
```

Then use the `$definition()` method:

``` r
nelder_mead$definition(
  algorithm = pracma::nelder_mead, # the optimization function
  arg_objective = "fn",            # the objective function argument name
  arg_initial = "x0",              # the argument name for the initial values
  out_value = "fmin",              # the optimal function value element
  out_parameter = "xmin",          # the optimal parameter element
  direction = "min"                # the optimizer minimizes
)
```

**3. Set a time limit**

Each optimizer object has a field called `$seconds`, which equals `Inf`
by default. You can set a different single numeric value to define a
time limit in seconds for the optimization:

``` r
nlm$seconds <- 10
nelder_mead$seconds <- 10
```

Note that not everything, especially compiled C code, can technically be
timed out. See the help page `help("withTimeout", package = "R.utils")`
for more details.

**4. Maximize the objective function**

Each optimizer object has the methods `$maximize()` and `$minimize()`
for function maximization and minimization, respectively. Both methods
require values for two arguments:

1.  `objective` (either an objective object as defined above or just a
    function) and
2.  `initial` (an initial parameter vector where the optimizer should
    start)

They optionally accept additional arguments for the objective function.
Optimizer-specific arguments should be set when creating the optimizer
object or via `$set_arguments()`.

``` r
nlm$maximize(objective = objective, initial = c(3, 3))
#> $value
#> [1] -6.559645
#> 
#> $parameter
#> [1] 1.974451 1.974451
#> 
#> $seconds
#> [1] 0.04005599
#> 
#> $initial
#> [1] 3 3
#> 
#> $error
#> [1] FALSE
#> 
#> $gradient
#> [1] 5.757896e-08 5.757896e-08
#> 
#> $code
#> [1] 1
#> 
#> $iterations
#> [1] 6
```

``` r
nelder_mead$maximize(objective = objective, initial = c(3, 3))
#> $value
#> [1] 0
#> 
#> $parameter
#> [1] 0 0
#> 
#> $seconds
#> [1] 0.02831006
#> 
#> $initial
#> [1] 3 3
#> 
#> $error
#> [1] FALSE
#> 
#> $count
#> [1] 105
#> 
#> $info
#> $info$solver
#> [1] "Nelder-Mead"
#> 
#> $info$restarts
#> [1] 0
```

Note that

- the inputs for the objective function and initial parameter values are
  named consistently across optimizers,

- the output values for the optimal parameter vector and maximum
  function value are also named consistently across optimizers,

- the output contains the initial parameter values, the optimization
  time in seconds, and other optimizer-specific elements,

- `pracma::nelder_mead` outperforms `stats::nlm` here both in
  optimization time and in convergence to the global maximum.

## Getting in touch

If you have any questions, found a bug, or need a feature, please [file
an issue on
GitHub](https://github.com/loelschlaeger/optimizeR/issues/new/choose).

NAME
    optimizer - Write your own Perl optimizer, in Perl

SYNOPSIS
      # Use Perl's default optimizer
      use optimizer 'C';

      # Use a Perl implementation of the default optimizer
      use optimizer 'perl';

      # Use an extension of the default optimizer
      use optimizer extend => sub {
            warn "goto considered harmful" if $_[0]-1>name eq "goto"
      }

      # Use a simple optimizer with callbacks for each op
      use optimizer callback => sub { .. }

      # Completely implement your own optimizre
      use optimizer mine => sub { ... }

      # use the standard optimizer with an extra callback
      # this is the most compatible optimizer version
      use optimizer 'extend-c' => sub { print $_[0]->name() };

      # don't provide a peep optimizer, rather get a callback
      # after we are finished with every code block
      use optimizer 'sub-detect' => sub { print $_[0]->name() };

      no optimizer; # Use the simplest working optimizer

DESCRIPTION
    This module allows you to replace the default Perl optree optimizer,
    "peep", with a Perl function of your own devising.

    It requires a Perl patched with the patch supplied with the module
    distribution; this patch allows the optimizer to be pluggable and
    replaceable with a C function pointer. This module provides the glue
    between the C function and a Perl subroutine. It is hoped that the patch
    will be integrated into the Perl core at some point soon. This patch is
    integrated as of perl 5.8.

    Your optimizer subroutine will be handed a "B::OP"-derived object
    representing the first (NOT the root) op in the program. You are
    expected to be fluent with the "B" module to know what to do with this.
    You can use "B::Generate" to fiddle around with the optree you are
    given, while traversing it in execution order.

    If you choose complete control over your optimizer, you must assign
    sequence numbers to operations. This can be done via the
    "optimizer::op_seqmax_inc" function, which supplies a new incremented
    sequence number. Do something like this:

        while ($$op) {
            $op->seq(optimizer::op_seqmax_inc);

            ... more optimizations ...

            $op = $op->next;
            last unless $op->can("next"); # Shouldn't get here
        }

    The "callback" option to this module will essentially do the above,
    calling your given subroutine with each op.

    If you just want to use this function to get a callback after every code
    block is compiled so you can do any arbitrary work on it use the
    "sub-detect" option, you will be passed LEAVE* ops after the standard
    peep optimizer has been run, this minimises the risk for bugs as we use
    the standard one. The op tree you are handed is also stable so you are
    free to work on it. This is usefull if you are limited by "CHECK" and
    "INIT" blocks as this works with string eval and "require" aswell. Only
    one callback per package is allowed.

STATUS
    relocatetopad() fails with threaded perls.

5.10 Changes
    Since Perl 5.10 there are no op_seqmax and op_seq numbers in CORE
    anymore, so we add a package global op_seqmax for the op-tree numbering,
    for $B::OP::seq also. This is not thread-safe.

AUTHOR
      Simon Cozens, C<simon@cpan.org>

    Extended functionality and current maintainer:

      Arthur Bergman, C<abergman@cpan.org>

    5.10 support by Reini Urban:

      Reini Urban, C<rurban@cpan.org>

SEE ALSO
    B::Generate, optimize

#' Dictionary of optimizer functions
#'
#' @description
#' A dictionary of currently included numerical optimizer functions in the
#' `{optimizeR}` package.
#'
#' @format
#' An \code{R6} object of class \code{\link[oeli]{Dictionary}}.
#'
#' @export
#'
#' @examples
#' print(optimizer_dictionary)

optimizer_dictionary <- oeli::Dictionary$new(
  key_name = "label",
  value_names = c(
    "algorithm",
    "arg_objective",
    "arg_initial",
    "arg_lower",
    "arg_upper",
    "arg_gradient",
    "arg_hessian",
    "gradient_as_attribute",
    "hessian_as_attribute",
    "out_value",
    "out_parameter",
    "direction"
  ),
  value_assert = alist(
    "algorithm" = checkmate::assert_function(),
    "arg_objective" = checkmate::assert_string(),
    "arg_initial" = checkmate::assert_string(),
    "arg_lower" = checkmate::assert_string(na.ok = TRUE),
    "arg_upper" = checkmate::assert_string(na.ok = TRUE),
    "arg_gradient" = checkmate::assert_string(na.ok = TRUE),
    "arg_hessian" = checkmate::assert_string(na.ok = TRUE),
    "gradient_as_attribute" = checkmate::assert_flag(),
    "hessian_as_attribute" = checkmate::assert_flag(),
    "out_value" = checkmate::assert_string(),
    "out_parameter" = checkmate::assert_string(),
    "direction" = checkmate::assert_choice(choices = c("min", "max"))
  ),
  allow_overwrite = FALSE,
  keys_reserved = c("custom"),
  dictionary_name = c("optimization algorithms")
)

optimizer_dictionary$add(
  "label" = "lbfgsb3c::lbfgsb3c",
  "algorithm" = lbfgsb3c::lbfgsb3c,
  "arg_objective" = "fn",
  "arg_lower" = "lower",
  "arg_upper" = "upper",
  "arg_gradient" = "gr",
  "arg_hessian" = NA,
  "gradient_as_attribute" = FALSE,
  "hessian_as_attribute" = FALSE,
  "arg_initial" = "par",
  "out_value" = "value",
  "out_parameter" = "par",
  "direction" = "min"
)

optimizer_dictionary$add(
  "label" = "lbfgsb3c::lbfgsb3",
  "algorithm" = lbfgsb3c::lbfgsb3,
  "arg_objective" = "fn",
  "arg_lower" = "lower",
  "arg_upper" = "upper",
  "arg_gradient" = "gr",
  "arg_hessian" = NA,
  "gradient_as_attribute" = FALSE,
  "hessian_as_attribute" = FALSE,
  "arg_initial" = "par",
  "out_value" = "value",
  "out_parameter" = "par",
  "direction" = "min"
)

optimizer_dictionary$add(
  "label" = "lbfgsb3c::lbfgsb3f",
  "algorithm" = lbfgsb3c::lbfgsb3f,
  "arg_objective" = "fn",
  "arg_lower" = "lower",
  "arg_upper" = "upper",
  "arg_gradient" = "gr",
  "arg_hessian" = NA,
  "gradient_as_attribute" = FALSE,
  "hessian_as_attribute" = FALSE,
  "arg_initial" = "par",
  "out_value" = "value",
  "out_parameter" = "par",
  "direction" = "min"
)

optimizer_dictionary$add(
  "label" = "lbfgsb3c::lbfgsb3x",
  "algorithm" = lbfgsb3c::lbfgsb3x,
  "arg_objective" = "fn",
  "arg_lower" = "lower",
  "arg_upper" = "upper",
  "arg_gradient" = "gr",
  "arg_hessian" = NA,
  "gradient_as_attribute" = FALSE,
  "hessian_as_attribute" = FALSE,
  "arg_initial" = "par",
  "out_value" = "value",
  "out_parameter" = "par",
  "direction" = "min"
)

optimizer_dictionary$add(
  "label" = "stats::nlm",
  "algorithm" = stats::nlm,
  "arg_objective" = "f",
  "arg_initial" = "p",
  "arg_lower" = NA,
  "arg_upper" = NA,
  "arg_gradient" = "gradient",
  "arg_hessian" = "hessian",
  "gradient_as_attribute" = TRUE,
  "hessian_as_attribute" = TRUE,
  "out_value" = "minimum",
  "out_parameter" = "estimate",
  "direction" = "min"
)

optimizer_dictionary$add(
  "label" = "stats::nlminb",
  "algorithm" = stats::nlminb,
  "arg_objective" = "objective",
  "arg_initial" = "start",
  "arg_lower" = "lower",
  "arg_upper" = "upper",
  "arg_gradient" = "gradient",
  "arg_hessian" = "hessian",
  "gradient_as_attribute" = FALSE,
  "hessian_as_attribute" = FALSE,
  "out_value" = "objective",
  "out_parameter" = "par",
  "direction" = "min"
)

optimizer_dictionary$add(
  "label" = "stats::optim",
  "algorithm" = stats::optim,
  "arg_objective" = "fn",
  "arg_initial" = "par",
  "arg_lower" = "lower",
  "arg_upper" = "upper",
  "arg_gradient" = "gr",
  "arg_hessian" = NA,
  "gradient_as_attribute" = FALSE,
  "hessian_as_attribute" = FALSE,
  "out_value" = "value",
  "out_parameter" = "par",
  "direction" = "min"
)

optimizer_dictionary$add(
  "label" = "ucminf::ucminf",
  "algorithm" = ucminf::ucminf,
  "arg_objective" = "fn",
  "arg_initial" = "par",
  "arg_lower" = NA,
  "arg_upper" = NA,
  "arg_gradient" = "gr",
  "arg_hessian" = NA,
  "gradient_as_attribute" = FALSE,
  "hessian_as_attribute" = FALSE,
  "out_value" = "value",
  "out_parameter" = "par",
  "direction" = "min"
)

#' Switch between parameter spaces
#'
#' @description
#' The \code{ParameterSpaces} object manages two related parameter spaces:
#'
#' - the Optimization Space (for optimization)
#' - the Interpretation Space (for easier interpretation).
#'
#' In the Optimization Space, parameters are stored as a \code{numeric}
#' \code{vector}, the standard format for numerical optimizers.
#'
#' In the Interpretation Space, parameters are stored as a \code{list} and can
#' take different formats (e.g., \code{matrix}).
#'
#' Users can define transformation functions (not necessarily bijective) to
#' switch between these spaces via the \code{$o2i()} and \code{$i2o()} methods.
#'
#' @examples
#' ### Log-likelihood function of two-class Gaussian mixture model with
#' ### parameter vector `theta` that consists of
#' ### - `mu`, mean vector of length 2
#' ### - `sd`, standard deviation vector of length 2, must be positive
#' ### - `lambda`, class probability of length 1, must be between 0 and 1
#'
#' normal_mixture_llk <- function(theta, data) {
#'   mu <- theta[1:2]
#'   sd <- exp(theta[3:4])
#'   lambda <- plogis(theta[5])
#'   c1 <- lambda * dnorm(data, mu[1], sd[1])
#'   c2 <- (1 - lambda) * dnorm(data, mu[2], sd[2])
#'   sum(log(c1 + c2))
#' }
#'
#' ### define parameter spaces
#' ### - `mu` needs no transformation
#' ### - `sd` needs to be real in optimization space and positive in
#' ###    interpretation space
#' ### - `lambda` needs to be real and of length `1` in optimization space, and
#' ###    a probability vector of length `2` in interpretation space
#'
#' normal_mixture_spaces <- ParameterSpaces$
#'   new(
#'     parameter_names = c("mu", "sd", "lambda"),
#'     parameter_lengths_in_o_space = c(2, 2, 1)
#'   )$
#'   o2i(
#'     "mu" = function(x) x,
#'     "sd" = function(x) exp(x),
#'     "lambda" = function(x) c(plogis(x), 1 - plogis(x))
#'   )$
#'   i2o(
#'     "mu" = function(x) x,
#'     "sd" = function(x) log(x),
#'     "lambda" = function(x) qlogis(x[1])
#'   )
#'
#' ### switch between parameter spaces
#'
#' par <- list(              # parameters in interpretation space
#'   "mu" = c(2, 4),
#'   "sd" = c(0.5, 1),
#'   "lambda" = c(0.4, 0.6)
#' )
#' (x <- normal_mixture_spaces$switch(par)) # switch to optimization space
#' normal_mixture_llk(
#'   theta = x, data = datasets::faithful$eruptions
#' )
#' normal_mixture_spaces$switch(x)          # switch back
#'
#' @export

ParameterSpaces <- R6::R6Class(

  classname = "ParameterSpaces",

  public = list(

    #' @description
    #' Initializes a new \code{ParameterSpaces} object.
    #'
    #' @param parameter_names \[`character()`\]\cr
    #' Unique names for the parameters.
    #'
    #' @param parameter_lengths_in_o_space \[`integer()`\]\cr
    #' The length of each parameter in the optimization space.
    #'
    #' @return
    #' A new \code{ParameterSpaces} object.

    initialize = function(
      parameter_names, parameter_lengths_in_o_space
    ) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(parameter_names),
        var_name = "parameter_names"
      )
      oeli::input_check_response(
        check = checkmate::check_names(parameter_names, type = "strict"),
        var_name = "parameter_names"
      )
      oeli::input_check_response(
        check = oeli::check_missing(parameter_lengths_in_o_space),
        var_name = "parameter_lengths_in_o_space"
      )
      oeli::input_check_response(
        check = checkmate::check_integerish(
          parameter_lengths_in_o_space, lower = 0,
          len = length(parameter_names), any.missing = FALSE
        ),
        var_name = "parameter_lengths_in_o_space"
      )

      ### set internal parameters
      private$.parameter_names <- p <- parameter_names
      private$.parameter_lengths_in_o_space <- n <-
        parameter_lengths_in_o_space
      private$.o2i <- {
        o2i <- replicate(length(n), function(x) x)
        names(o2i) <- p
        o2i
      }
      private$.i2o <- {
        i2o <- replicate(length(n), function(x) as.vector(x))
        names(i2o) <- p
        i2o
      }

    },

    #' @description
    #' Print an overview of the parameter spaces.
    #'
    #' @param show_transformer \[`logical(1)`\]\cr
    #' Show transformer functions in the output?

    print = function(show_transformer = FALSE) {

      ### input checks
      oeli::input_check_response(
        check = checkmate::check_flag(show_transformer),
        var_name = "show_transformer"
      )

      ### optimization space
      cli::cli_h1(paste0(
        "Optimization Space {.cls numeric(",
        private$.o_space_length(),
        ")}"
      ))
      print.data.frame(
        structure(
          data.frame(private$.format_ranges(), private$.parameter_names),
          names = NULL
        ),
        row.names = FALSE, right = FALSE
      )
      if (show_transformer) {
        cli::cli_h3("Transformation to Interpretation Space:")
        print.data.frame(
          structure(
            data.frame(
              private$.parameter_names,
              sapply(private$.o2i, oeli::function_body)
            ),
            names = NULL
          ),
          row.names = FALSE, right = FALSE
        )
      }

      ### interpretation space
      cli::cli_h1(paste0(
        "Interpretation Space {.cls list(",
        private$.number_parameters(),
        ")}"
      ))
      print.data.frame(
        structure(
          data.frame(
            sapply(
              seq_along(private$.parameter_names),
              function(i) sprintf("[[%d]]", i)
            ),
            private$.parameter_names),
          names = NULL
        ),
        row.names = FALSE, right = FALSE
      )
      if (show_transformer) {
        cli::cli_h3("Transformation to Optimization Space:")
        print.data.frame(
          structure(
            data.frame(
              private$.parameter_names,
              sapply(private$.i2o, oeli::function_body)
            ),
            names = NULL
          ),
          row.names = FALSE, right = FALSE
        )
      }

      cat("\n")
      invisible(self)
    },

    #' @description
    #' Switch between Optimization Space and Interpretation Space.
    #'
    #' @param x \[`numeric()` | `list()`\]\cr
    #' The parameters, either as a `numeric vector` (will be switched to
    #' Interpretation Space), or as a `list()` (will be switched to
    #' Optimization Space).
    #'
    #' @param to \[`character(1)` | `NULL`\]\cr
    #' Explicitly switch to a specific space, either
    #'
    #' - `"o"`: Optimization Space
    #' - `"i"`: Interpretation Space
    #'
    #' If `NULL`, the function will switch to the other space.

    switch = function(x, to = NULL) {

      ### input checks
      oeli::input_check_response(
        check = checkmate::check_choice(to, c("o", "i"), null.ok = TRUE),
        var_name = "to"
      )
      oeli::input_check_response(
        check = oeli::check_missing(x),
        var_name = "x"
      )

      if (oeli::test_numeric_vector(x)) {

        ### input check
        oeli::input_check_response(
          check = oeli::check_numeric_vector(
            x, any.missing = FALSE, len = private$.o_space_length()
          ),
          var_name = "x"
        )

        ### stay in Optimization Space?
        if (checkmate::test_choice(to, c("o"), null.ok = FALSE)) {
          return(x)
        }

        ### transform to Interpretation Space
        out <- setNames(
          vector("list", private$.number_parameters()),
          private$.parameter_names
        )
        ranges <- private$.get_ranges()
        x_split <- lapply(ranges, function(start_end) {
          if (is.null(start_end)) {
            NULL
          } else {
            x[start_end[1]:start_end[2]]
          }
        })
        names(x_split) <- private$.parameter_names
        for (parameter in names(out)) {
          out[[parameter]] <- private$.o2i[[parameter]](x_split[[parameter]])
        }
        return(out)

      } else if (checkmate::test_list(x)) {

        ### input check
        oeli::input_check_response(
          check = checkmate::check_names(
            names(x), subset.of = private$.parameter_names, type = "strict"
          ),
          var_name = "x"
        )

        ### stay in Interpretation Space?
        if (checkmate::test_choice(to, c("i"), null.ok = FALSE)) {
          return(x)
        }

        ### transform to Optimization Space
        out <- numeric(private$.o_space_length())
        i2o_parts <- list()
        for (i in seq_along(private$.parameter_names)) {
          par_name <- private$.parameter_names[i]
          part <- private$.i2o[[par_name]](x[[par_name]])
          oeli::input_check_response(
            check = oeli::check_numeric_vector(
              part, len = private$.parameter_lengths_in_o_space[i],
              any.missing = FALSE, null.ok = TRUE
            ),
            var_name = paste0("x[[\"", par_name, "\"]]"),
            prefix = "Transforming {.var {var_name}} is bad:"
          )
          i2o_parts[[i]] <- part
        }
        return(unlist(i2o_parts))

      } else {

        ### bad input type
        cli::cli_abort(
          "Input {.code x} must be a {.cls numeric vector} or a {.cls list},
          but is of class {.cls {class(x)}}.",
          call = NULL
        )
      }

    },

    #' @description
    #' Define transformation functions when switching from Optimization Space
    #' to Interpretation Space.
    #'
    #' @param ... \[`function`\]\cr
    #' One or more transformation functions, named according to the parameters.
    #'
    #' Transformers from Optimization Space to Interpretation Space (o2i)
    #' **must receive** a `numeric`. The default is the identity.

    o2i = function(...) {
      input <- list(...)
      oeli::input_check_response(
        check = checkmate::check_list(input, types = "function")
      )
      oeli::input_check_response(
        check = checkmate::check_names(
          names(input), subset.of = private$.parameter_names
        )
      )
      private$.o2i <-
        oeli::merge_lists(input, private$.o2i)[private$.parameter_names]
      invisible(self)
    },

    #' @description
    #' Define transformation functions when switching from Interpretation Space
    #' to Optimization Space.
    #'
    #' @param ... \[`function`\]\cr
    #' One or more transformation functions, named according to the parameters.
    #'
    #' Transformers from Interpretation Space to Optimization Space (i2o)
    #' **must return** a `numeric`. The default is `as.vector()`.

    i2o = function(...) {
      input <- list(...)
      oeli::input_check_response(
        check = checkmate::check_list(input, types = "function")
      )
      oeli::input_check_response(
        check = checkmate::check_names(
          names(input), subset.of = private$.parameter_names
        )
      )
      private$.i2o <-
        oeli::merge_lists(input, private$.i2o)[private$.parameter_names]
      invisible(self)
    }

  ),

  private = list(

    .parameter_names = character(),
    .parameter_lengths_in_o_space = 0,
    .o2i = list(),
    .i2o = list(),

    .number_parameters = function(names = private$.parameter_names) {
      length(names)
    },

    .o_space_length = function(
      lengths = private$.parameter_lengths_in_o_space
    ) {
      sum(lengths)
    },

    .get_ranges = function(lengths = private$.parameter_lengths_in_o_space) {
      lapply(seq_along(lengths), function(i) {
        if (lengths[i] == 0) NULL else {
          start <- if (i == 1) 1 else sum(lengths[1:(i - 1)]) + 1
          end <- start - 1 + lengths[i]
          c(start, end)
        }
      })
    },

    .format_ranges = function(ranges = private$.get_ranges()) {
      sapply(ranges, function(x) {
        if (is.null(x)) "[NULL]" else sprintf("[%d:%d]", x[1], x[2])
      })
    }

  )

)

test_that("Gaussian mixture model parameter spaces work", {
  ### define parameter spaces
  normal_mixture_spaces <- ParameterSpaces$
    new(
    parameter_names = c("mu", "sd", "lambda"),
    parameter_lengths_in_o_space = c(2, 2, 1)
  )$
    o2i(
    "mu" = function(x) x,
    "sd" = function(x) exp(x),
    "lambda" = function(x) c(plogis(x), 1 - plogis(x))
  )$
    i2o(
    "mu" = function(x) x,
    "sd" = function(x) log(x),
    "lambda" = function(x) qlogis(x[1])
  )
  expect_snapshot(
    print(normal_mixture_spaces, show_transformer = TRUE)
  )

  ### switch between parameter spaces
  par <- list( # parameters in interpretation space
    "mu" = c(2, 4),
    "sd" = c(0.5, 1),
    "lambda" = c(0.4, 0.6)
  )
  expect_identical(
    par,
    normal_mixture_spaces$switch(par, to = "i")
  )
  x <- normal_mixture_spaces$switch(par) # switch to optimization space
  expect_equal(
    round(x, 2), c(2, 4, -0.69, 0, -0.41)
  )
  expect_identical(
    x,
    normal_mixture_spaces$switch(x, to = "o")
  )
  expect_equal(
    normal_mixture_spaces$switch(x), # switch back
    par
  )
})

test_that("Probit parameter spaces work", {
  ### define parameter spaces
  parameter_names <- c("b", "Omega", "Sigma")
  parameter_lengths_in_o_space <- c(3, 6, 3)
  probit_parameter <- ParameterSpaces$new(
    parameter_names = parameter_names,
    parameter_lengths_in_o_space = parameter_lengths_in_o_space
  )
  probit_parameter$o2i(
    "Omega" = function(x) oeli::chol_to_cov(x),
    "Sigma" = function(x) oeli::undiff_cov(oeli::chol_to_cov(x))
  )
  probit_parameter$i2o(
    "Omega" = function(x) oeli::cov_to_chol(x),
    "Sigma" = function(x) oeli::cov_to_chol(oeli::diff_cov(x))
  )
  expect_snapshot(
    print(probit_parameter, TRUE)
  )

  ### switch between parameter spaces
  par <- list(
    b = c(1, 2, 3),
    Omega = oeli::sample_covariance_matrix(dim = 3),
    Sigma = oeli::sample_covariance_matrix(dim = 3)
  )
  x <- probit_parameter$switch(x = par)
  checkmate::expect_numeric(x, len = 12)
  par2 <- probit_parameter$switch(x = x)
  checkmate::expect_list(par2, len = 3)
  expect_identical(par$b, par2$b)
  expect_identical(round(par$Omega, 2), round(par2$Omega, 2))
  expect_identical(
    round(oeli::diff_cov(par$Sigma), 2),
    round(oeli::diff_cov(par2$Sigma), 2)
  )

  ### catch errors
  expect_error(
    probit_parameter$switch(rnorm(13)),
    "Input `x` is bad: Must have length 12, but has length 13"
  )
  expect_error(
    probit_parameter$switch(c(par, list("bad" = 1))),
    "Input `x` is bad: Names must be a subset of"
  )
  expect_error(
    probit_parameter$switch(list(
      b = 1,
      Omega = oeli::sample_covariance_matrix(dim = 3),
      Sigma = oeli::sample_covariance_matrix(dim = 3)
    )),
    "Must have length 3, but has length 1"
  )
  expect_error(
    probit_parameter$switch("bad"),
    "Input `x` must be"
  )
})

test_that("Parameter spaces with zero length parameter work", {
  ### define parameter spaces
  zero_parameter_spaces <- ParameterSpaces$
    new(
    parameter_names = c("x", "y", "z"),
    parameter_lengths_in_o_space = c(1, 0, 1)
  )$
    o2i(
    "y" = function(x) c("A", "B")
  )$
    i2o(
    "y" = function(x) c()
  )
  expect_snapshot(
    print(zero_parameter_spaces, show_transformer = TRUE)
  )

  ### switch between parameter spaces
  par <- list("x" = 1, "y" = c("A", "B"), "z" = 2)
  x <- zero_parameter_spaces$switch(par) # switch to optimization space
  expect_equal(x, c(1, 2))
  expect_equal(
    zero_parameter_spaces$switch(x), # switch back
    par
  )
})

test_that("Parameter spaces with a subset of parameters work", {
  ### define parameter spaces
  subset_parameter_spaces <- ParameterSpaces$
    new(
      parameter_names = c("x", "y", "z"),
      parameter_lengths_in_o_space = c(1, 0, 1)
    )

  self <- subset_parameter_spaces
  private <- self$.__enclos_env__$private

  ### switch between parameter spaces
  par <- list("x" = 1, "z" = 3)
  x <- subset_parameter_spaces$switch(par) # switch to optimization space
  expect_equal(x, c(1, 3))
  expect_equal(
    subset_parameter_spaces$switch(x), # switch back
    par
  )
})

#' Specify objective function object
#'
#' @description
#' The \code{Objective} object specifies the framework for an objective
#' function for numerical optimization.
#'
#' @param target \[`character()`\]\cr
#' The argument name(s) to optimize.
#'
#' All target arguments must be \code{numeric}.
#'
#' If \code{NULL} (default), the first function argument is selected.
#'
#' @param npar \[`integer()`\]\cr
#' The length of each target argument, i.e., the length(s) of the
#' \code{numeric} \code{vector} argument(s) specified by \code{target}.
#'
#' @param ...
#' Optionally additional function arguments that are fixed during the
#' optimization.
#'
#' @param .verbose \[`logical(1)`\]\cr
#' Print status messages?
#'
#' @param argument_name \[`character(1)`\]\cr
#' A function argument name.
#'
#' @param .at \[`numeric()`\]\cr
#' The values for the target argument(s), written in a single vector.
#'
#' Must be of length \code{sum(self$npar)}.
#'
#' @param .negate \[`logical(1)`\]\cr
#' Negate the function return value?
#'
#' @return
#' An \code{Objective} object.
#'
#' @export
#'
#' @examples
#' ### define log-likelihood function of Gaussian mixture model
#' llk <- function(mu, sd, lambda, data) {
#'   sd <- exp(sd)
#'   lambda <- plogis(lambda)
#'   cluster_1 <- lambda * dnorm(data, mu[1], sd[1])
#'   cluster_2 <- (1 - lambda) * dnorm(data, mu[2], sd[2])
#'   sum(log(cluster_1 + cluster_2))
#' }
#'
#' ### optimize over the first three arguments, the 'data' argument is constant
#' objective <- Objective$new(
#'   f = llk, target = c("mu", "sd", "lambda"), npar = c(2, 2, 1),
#'   data = faithful$eruptions
#' )
#'
#' ### evaluate at 1:5 (1:2 is passed to mu, 3:4 to sd, and 5 to lambda)
#' objective$evaluate(1:5)

Objective <- R6::R6Class(

  classname = "Objective",

  public = list(

    #' @description
    #' Creates a new \code{Objective} object.
    #'
    #' @param f \[`function`\]\cr
    #' A \code{function} to be optimized.
    #'
    #' It is expected that \code{f} has at least one \code{numeric} argument.
    #'
    #' Also, the return value of \code{f} is expected to have the
    #' structure \code{numeric(1)}, i.e. a single \code{numeric} value.

    initialize = function(f, target = NULL, npar, ...) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(f),
        var_name = "f"
      )
      oeli::input_check_response(
        check = checkmate::check_function(f),
        var_name = "f"
      )
      if (is.null(target)) {
        target <- oeli::function_arguments(f, with_ellipsis = FALSE)[1]
      }
      oeli::input_check_response(
        check = checkmate::check_character(
          target, any.missing = FALSE, min.len = 1
        ),
        var_name = "target"
      )
      oeli::input_check_response(
        check = checkmate::check_function(f, args = target),
        var_name = "f"
      )
      oeli::input_check_response(
        check = oeli::check_missing(npar),
        var_name = "npar"
      )
      oeli::input_check_response(
        check = checkmate::check_integerish(
          npar, lower = 1, any.missing = FALSE, len = length(target)
        ),
        var_name = "f"
      )
      arguments <- list(...)
      arguments <- c(
        arguments,
        oeli::function_defaults(f, names(arguments))
      )

      ### define objective
      do.call(self$set_argument, c(arguments, list(.verbose = FALSE)))
      self$objective_name <- oeli::variable_name(f)
      private$.f <- f
      private$.target <- target
      private$.npar <- npar
    },

    #' @description
    #' Set a function argument that remains fixed during optimization.
    #'
    #' @param .overwrite \[`logical(1)`\]\cr
    #' Overwrite existing values?

    set_argument = function(..., .overwrite = TRUE, .verbose = self$verbose) {

      ### input checks
      oeli::input_check_response(
        check = checkmate::check_flag(.overwrite),
        var_name = ".overwrite"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.verbose),
        var_name = ".verbose"
      )
      arguments <- list(...)
      if (length(arguments) > 0) {
        oeli::input_check_response(
          check = checkmate::check_names(names(arguments), type = "strict"),
          var_name = "..."
        )
      }

      ### set arguments
      argument_names <- names(arguments)
      for (i in seq_along(arguments)) {
        if (argument_names[i] %in% names(private$.arguments)) {
          if (!.overwrite) {
            cli::cli_abort(
              "Argument {.var {argument_names[i]}} already exists.",
              call = NULL
            )
          } else {
            if (.verbose) {
              cli::cli_alert(
                "Overwriting argument {.val {argument_names[i]}}."
              )
            }
          }
        } else {
          if (.verbose) {
            cli::cli_alert("Setting argument {.val {argument_names[i]}}.")
          }
        }
        private$.arguments[argument_names[i]] <- arguments[i]
      }

      ### synchronize with gradient and Hessian (if available)
      private$.sync_arguments(.verbose = .verbose)

      invisible(self)

    },

    #' @description
    #' Get a fixed function argument.

    get_argument = function(argument_name, .verbose = self$verbose) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(argument_name),
        var_name = "argument_name"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.verbose),
        var_name = ".verbose"
      )
      private$.check_argument_specified(argument_name, .verbose = .verbose)

      ### get argument
      if (.verbose) {
        cli::cli_alert("Returning argument {.val {argument_name}}.")
      }
      private$.arguments[[argument_name]]

    },

    #' @description
    #' Remove a fixed function argument.

    remove_argument = function(argument_name, .verbose = self$verbose) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(argument_name),
        var_name = "argument_name"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.verbose),
        var_name = ".verbose"
      )
      private$.check_argument_specified(argument_name, .verbose = .verbose)

      ### remove argument
      if (.verbose) {
        cli::cli_alert("Removing argument {.val {argument_name}}.")
      }
      private$.arguments[[argument_name]] <- NULL

      ### synchronize with gradient and Hessian (if available)
      private$.sync_arguments(.verbose = .verbose)

      invisible(self)

    },

    #' @description
    #' Set a gradient function.
    #'
    #' @param gradient \[`function`\]\cr
    #' A \code{function} that computes the gradient of the objective function
    #' \code{f}.
    #'
    #' It is expected that \code{gradient} has the same call as \code{f}, and
    #' that \code{gradient} returns a \code{numeric} \code{vector} of length
    #' \code{sum(self$npar)}.

    set_gradient = function(
      gradient, target = self$target, npar = self$npar, ...,
      .verbose = self$verbose
    ) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(gradient),
        var_name = "gradient"
      )

      ### determine arguments
      arguments <- oeli::merge_lists(list(...), private$.arguments)

      ### setting gradient
      private$.gradient <- do.call(
        Objective$new,
        c(list(f = gradient, target = target, npar = npar), arguments)
      )
      private$.gradient$objective_name <- oeli::variable_name(
        gradient, fallback = "gradient"
      )
      if (.verbose) {
        cli::cli_alert("Setting gradient function.")
      }

      invisible(self)
    },

    #' @description
    #' Set a Hessian function.
    #'
    #' @param hessian \[`function`\]\cr
    #' A \code{function} that computes the Hessian of the objective function
    #' \code{f}.
    #'
    #' It is expected that \code{hessian} has the same call as \code{f}, and
    #' that \code{hessian} returns a \code{numeric} \code{matrix} of dimension
    #' \code{sum(self$npar)} times \code{sum(self$npar)}.

    set_hessian = function(
      hessian, target = self$target, npar = self$npar, ...,
      .verbose = self$verbose
    ) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(hessian),
        var_name = "hessian"
      )

      ### determine arguments
      arguments <- oeli::merge_lists(list(...), private$.arguments)

      ### setting Hessian
      private$.hessian <- do.call(
        Objective$new,
        c(list(f = hessian, target = target, npar = npar), arguments)
      )
      private$.hessian$objective_name <- oeli::variable_name(
        hessian, fallback = "hessian"
      )
      if (.verbose) {
        cli::cli_alert("Setting Hessian function.")
      }

      invisible(self)
    },

    #' @description
    #' Evaluate the objective function.
    #'
    #' @param .gradient_as_attribute \[`logical(1)`\]\cr
    #' Add the value of the gradient function as an attribute to the output?
    #'
    #' The attribute name is defined via the `.gradient_attribute_name`
    #' argument.
    #'
    #' Ignored if `$gradient_specified` and `.gradient_numeric` are `FALSE`.
    #'
    #' @param .gradient_attribute_name \[`character(1)`\]\cr
    #' Only relevant if `.gradient_as_attribute = TRUE`.
    #'
    #' In that case, the attribute name for the gradient (if available).
    #'
    #' @param .gradient_numeric \[`logical(1)`\]\cr
    #' Calculate the gradient via the numerical approximation
    #' \code{\link[numDeriv]{grad}}?
    #'
    #' @param .hessian_as_attribute \[`logical(1)`\]\cr
    #' Add the value of the Hessian function as an attribute to the output?
    #'
    #' The attribute name is defined via the `.hessian_attribute_name`
    #' argument.
    #'
    #' Ignored if `$hessian_specified` and `hessian_numeric` are `FALSE`.
    #'
    #' @param .hessian_attribute_name \[`character(1)`\]\cr
    #' Only relevant if `.hessian_as_attribute = TRUE`.
    #'
    #' In that case, the attribute name for the Hessian (if available).
    #'
    #' @param .hessian_numeric \[`logical(1)`\]\cr
    #' Calculate the Hessian via the numerical approximation
    #' \code{\link[numDeriv]{hessian}}?

    evaluate = function(
      .at,
      .negate = FALSE,
      .gradient_as_attribute = FALSE,
      .gradient_attribute_name = "gradient",
      .gradient_numeric = FALSE,
      .hessian_as_attribute = FALSE,
      .hessian_attribute_name = "hessian",
      .hessian_numeric = FALSE,
      ...
    ) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(.at),
        var_name = ".at"
      )
      private$.check_target(.at)
      private$.check_arguments_complete(
        .names_add_args_provided = names(list(...))
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.negate),
        var_name = ".negate"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.gradient_as_attribute),
        var_name = ".gradient_as_attribute"
      )
      oeli::input_check_response(
        check = checkmate::check_string(
          .gradient_attribute_name, na.ok = !.gradient_as_attribute
        ),
        var_name = ".gradient_attribute_name"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.gradient_numeric),
        var_name = ".gradient_numeric"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.hessian_as_attribute),
        var_name = ".hessian_as_attribute"
      )
      oeli::input_check_response(
        check = checkmate::check_string(
          .hessian_attribute_name, na.ok = !.hessian_as_attribute
        ),
        var_name = ".hessian_attribute_name"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.hessian_numeric),
        var_name = ".hessian_numeric"
      )

      ### evaluation
      splits <- c(0, cumsum(private$.npar))
      .at_split <- structure(
        lapply(seq_along(splits)[-1], function(i) {
          .at[(splits[i - 1] + 1):(splits[i])]
        }),
        names = private$.target
      )
      setTimeLimit(
        cpu = self$seconds,
        elapsed = self$seconds,
        transient = TRUE
      )
      on.exit({
        setTimeLimit(cpu = Inf, elapsed = Inf, transient = FALSE)
      })
      args <- c(.at_split, oeli::merge_lists(list(...), private$.arguments))
      out <- tryCatch(
        {
          suppressWarnings(
            value <- do.call(what = private$.f, args = args),
            classes = if (self$hide_warnings) "warning" else ""
          )
          if (.negate) -value else value
        },
        error = function(e) {
          msg <- e$message
          time_limit_reached <- grepl(
            "reached elapsed time limit|reached CPU time limit",
            msg
          )
          if (time_limit_reached) {
            return("time limit reached")
          } else {
            cli::cli_abort(
              paste("Function evaluation threw an error:", msg),
              call = NULL
            )
          }
        }
      )

      ### add gradient and Hessian
      if (.gradient_as_attribute) {
        if (.gradient_numeric) {
          attr(out, .gradient_attribute_name) <-
            self$evaluate_gradient_numeric(
              .at = .at, .negate = .negate, ...
            )
        } else if (self$gradient_specified) {
          attr(out, .gradient_attribute_name) <- self$evaluate_gradient(
            .at = .at, .negate = .negate, ...
          )
        }
      }
      if (.hessian_as_attribute) {
        if (.hessian_numeric) {
          attr(out, .hessian_attribute_name) <- self$evaluate_hessian_numeric(
            .at = .at, .negate = .negate, ...
          )
        } else if (self$hessian_specified) {
          attr(out, .hessian_attribute_name) <- self$evaluate_hessian(
            .at = .at, .negate = .negate, ...
          )
        }
      }

      ### return
      return(out)

    },

    #' @description
    #' Evaluate the gradient function.
    #'
    #' Returns a \code{numeric} vector of \code{NA_real_} values if the
    #' evaluation fails or returns an unexpected result.

    evaluate_gradient = function(.at, .negate = FALSE, ...) {
      if (self$gradient_specified) {
        oeli::input_check_response(
          check = oeli::check_missing(.at),
          var_name = ".at"
        )
        out <- tryCatch(
          private$.gradient$evaluate(.at = .at, .negate = .negate, ...),
          error = function(e) private$.fallback_gradient()
        )
        private$.as_gradient(out)
      } else {
        cli::cli_abort(paste(
            "Gradient function is required but not specified yet."
          ),
          call = NULL
        )
      }
    },

    #' @description
    #' Evaluate the numerical gradient \code{\link[numDeriv]{grad}}.
    #'
    #' Returns a \code{numeric} vector of \code{NA_real_} values if the
    #' calculation fails or returns an unexpected result.

    evaluate_gradient_numeric = function(.at, .negate = FALSE, ...) {
      oeli::input_check_response(
        check = oeli::check_missing(.at),
        var_name = ".at"
      )
      out <- tryCatch(
        suppressWarnings(
          do.call(
            what = numDeriv::grad,
            args = list(func = self$evaluate, x = .at, .negate = .negate, ...)
          )
        ),
        error = function(e) private$.fallback_gradient()
      )
      private$.as_gradient(out)
    },

    #' @description
    #' Evaluate the Hessian function.
    #'
    #' Returns an \code{NA_real_} value or matrix if the evaluation fails or
    #' returns an unexpected result.

    evaluate_hessian = function(.at, .negate = FALSE, ...) {
      if (self$hessian_specified) {
        oeli::input_check_response(
          check = oeli::check_missing(.at),
          var_name = ".at"
        )
        out <- tryCatch(
          private$.hessian$evaluate(.at = .at, .negate = .negate, ...),
          error = function(e) private$.fallback_hessian()
        )
        private$.as_hessian(out, scalar_ok = TRUE)
      } else {
        cli::cli_abort(paste(
            "Hessian function is required but not specified yet."
          ),
          call = NULL
        )
      }
    },

    #' @description
    #' Evaluate the numerical Hessian \code{\link[numDeriv]{hessian}}.
    #'
    #' Returns an \code{NA_real_} matrix if the calculation fails or returns an
    #' unexpected result.

    evaluate_hessian_numeric = function(.at, .negate = FALSE, ...) {
      oeli::input_check_response(
        check = oeli::check_missing(.at),
        var_name = ".at"
      )
      out <- tryCatch(
        suppressWarnings(
          do.call(
            what = numDeriv::hessian,
            args = list(func = self$evaluate, x = .at, .negate = .negate, ...)
          )
        ),
        error = function(e) private$.fallback_hessian()
      )
      private$.as_hessian(out)
    },

    #' @description
    #' Print details of the \code{Objective} object.

    print = function() {
      cli::cat_bullet(c(
        paste(
          "Function:", private$.objective_name
        ),
        paste(
          "Targets (length):",
          paste(
            paste0(private$.target, " (", private$.npar, ")"), collapse = ", "
          )
        ),
        paste(
          "Fixed arguments:",
          if(length(private$.arguments) == 0) {
            "none"
          } else {
            paste(names(private$.arguments), collapse = ", ")
          },
          collapse = ", "
        )
      ))
      invisible(self)
    }

  ),

  active = list(

    #' @field objective_name \[`character(1)`\]\cr
    #' The label for the objective function.

    objective_name = function(value) {
      if (missing(value)) {
        return(private$.objective_name)
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value),
        )
        private$.objective_name <- value
      }
    },

    #' @field fixed_arguments \[`character()`, read-only\]\cr
    #' The name(s) of the fixed argument(s) (if any).

    fixed_arguments = function(value) {
      if (missing(value)) {
        names(private$.arguments)
      } else {
        cli::cli_abort(
          "Field {.var fixed_arguments} is read-only.",
          call = NULL
        )
      }
    },

    #' @field seconds \[`numeric(1)`\]\cr
    #' A time limit in seconds. Computations are interrupted
    #' prematurely if \code{seconds} is exceeded.
    #'
    #' No time limit if \code{seconds = Inf} (the default).
    #'
    #' Note the limitations documented in \code{\link[base]{setTimeLimit}}.

    seconds = function(value) {
      if (missing(value)) {
        return(private$.seconds)
      } else {
        oeli::input_check_response(
          check = checkmate::check_number(value, lower = 0, finite = FALSE)
        )
        private$.seconds <- value
      }
    },

    #' @field hide_warnings \[`logical(1)`\]\cr
    #' Hide warnings when evaluating the objective function?

    hide_warnings = function(value) {
      if (missing(value)) {
        return(private$.hide_warnings)
      } else {
        oeli::input_check_response(
          check = checkmate::check_flag(value)
        )
        private$.hide_warnings <- value
      }
    },

    #' @field verbose \[`logical(1)`\]\cr
    #' Print status messages?

    verbose = function(value) {
      if (missing(value)) {
        return(private$.verbose)
      } else {
        oeli::input_check_response(
          check = checkmate::check_flag(value),
          var_name = "verbose"
        )
        private$.verbose <- value
      }
    },

    #' @field npar \[`integer()`, read-only\]\cr
    #' The length of each target argument.

    npar = function(value) {
      if (missing(value)) {
        structure(private$.npar, names = private$.target)
      } else {
        cli::cli_abort(
          "Field {.var npar} is read-only.",
          call = NULL
        )
      }
    },

    #' @field target \[`character()`, read-only\]\cr
    #' The argument name(s) to optimize.

    target = function(value) {
      if (missing(value)) {
        private$.target
      } else {
        cli::cli_abort(
          "Field {.var target} is read-only.",
          call = NULL
        )
      }
    },

    #' @field gradient_specified \[`logical(1)`, read-only\]\cr
    #' Whether a gradient function has been specified via `$set_gradient()`.

    gradient_specified = function(value) {
      if (missing(value)) {
        !is.null(private$.gradient)
      } else {
        cli::cli_abort(
          "Field {.var gradient_specified} is read-only.",
          call = NULL
        )
      }
    },

    #' @field hessian_specified \[`logical(1)`, read-only\]\cr
    #' Whether a Hessian function has been specified via `$set_hessian()`.

    hessian_specified = function(value) {
      if (missing(value)) {
        !is.null(private$.hessian)
      } else {
        cli::cli_abort(
          "Field {.var hessian_specified} is read-only.",
          call = NULL
        )
      }
    }

  ),

  private = list(

    .f = NULL,
    .objective_name = character(),
    .target = character(),
    .npar = integer(),
    .arguments = list(),
    .seconds = Inf,
    .hide_warnings = FALSE,
    .verbose = getOption("verbose", default = FALSE),
    .gradient = NULL,
    .hessian = NULL,

    .as_gradient = function(value) {
      if (
        checkmate::test_numeric(
          value,
          any.missing = FALSE,
          finite = TRUE,
          len = private$.target_length()
        ) &&
        is.null(dim(value))
      ) {
        return(as.numeric(value))
      }
      private$.fallback_gradient()
    },

    .as_hessian = function(value, scalar_ok = FALSE) {
      n <- private$.target_length()
      if (
        scalar_ok &&
        n == 1 &&
        checkmate::test_number(value, na.ok = FALSE, finite = TRUE)
      ) {
        return(as.numeric(value))
      }
      if (
        is.matrix(value) &&
        all(dim(value) == c(n, n)) &&
        checkmate::test_numeric(value, any.missing = FALSE, finite = TRUE)
      ) {
        return(matrix(
          as.numeric(value),
          nrow = n,
          dimnames = dimnames(value)
        ))
      }
      if (scalar_ok && n == 1) {
        return(NA_real_)
      }
      private$.fallback_hessian()
    },

    .fallback_gradient = function() {
      rep(NA_real_, private$.target_length())
    },

    .fallback_hessian = function() {
      n <- private$.target_length()
      matrix(NA_real_, nrow = n, ncol = n)
    },

    .target_length = function() {
      as.integer(sum(private$.npar))
    },

    ### helper function that checks the target argument
    .check_target = function(.at, .verbose = self$verbose) {

      oeli::input_check_response(
        check = checkmate::check_numeric(
          .at, any.missing = FALSE, len = sum(private$.npar)
        ),
        var_name = oeli::variable_name(.at, fallback = ".at")
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.verbose),
        var_name = ".verbose"
      )
      if (.verbose) {
        cli::cli_alert_success(paste(
          "The value{?s} for the {length(private$.npar)} target argument{?s}",
          "{?is/are} correctly specified."
        ))
      }
      invisible(TRUE)

    },

    ### helper function that checks if a function argument is specified
    .check_argument_specified = function(
      argument_name, .verbose = self$verbose
    ) {

      oeli::input_check_response(
        check = checkmate::check_string(argument_name),
        var_name = "argument_name"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.verbose),
        var_name = ".verbose"
      )

      if (!argument_name %in% names(private$.arguments)) {
        cli::cli_abort(paste(
            "Function argument {.var {argument_name}} is required but not",
            "specified yet."
          ),
          call = NULL
        )
      }
      if (.verbose) {
        cli::cli_alert_success(
          "Required argument {.val {argument_name}} is specified."
        )
      }
      invisible(TRUE)

    },

    ### helper function that checks if all required arguments are specified
    .check_arguments_complete = function(
      .verbose = self$verbose, .names_add_args_provided = character()
    ) {

      oeli::input_check_response(
        check = checkmate::check_flag(.verbose),
        var_name = ".verbose"
      )
      oeli::input_check_response(
        check = checkmate::check_character(
          .names_add_args_provided, any.missing = FALSE, null.ok = TRUE
        ),
        var_name = ".names_add_args_provided"
      )
      arguments_required <- oeli::function_arguments(
        private$.f, with_default = FALSE, with_ellipsis = FALSE
      )
      check_argument_available_names <- setdiff(
        arguments_required, c(private$.target, .names_add_args_provided)
      )
      for (argument_name in check_argument_available_names) {
        private$.check_argument_specified(argument_name, .verbose = FALSE)
      }
      if (.verbose) {
        cli::cli_alert_success(
          "All required fixed arguments are specified."
        )
      }

    },

    ### helper function to synchronize arguments with gradient and Hessian
    ### function (if specified)
    .sync_arguments = function(.verbose = self$verbose) {

        if (!is.null(private$.gradient)) {
          private$.gradient$.__enclos_env__$private$.arguments <-
            private$.arguments
          if (.verbose) {
            cli::cli_alert("Synchronized arguments with gradient function.")
          }
        }

        if (!is.null(private$.gradient)) {
          private$.hessian$.__enclos_env__$private$.arguments <-
            private$.arguments
          if (.verbose) {
            cli::cli_alert("Synchronized arguments with Hessian function.")
          }
        }

    }

  )

)

# self <- objective
# private <- self$.__enclos_env__$private

cli::test_that_cli("test various cli messages", {

   ### objective definition
   f <- function(x, a, b = 0) (x + a)^2 + b
   f_gradient <- function(x, a, b = 0) 2 * x + 2 * a
   f_hessian <- function(x, a, b = 0) 2
   objective <- Objective$new(f = f, npar = 1)
   objective$verbose <- TRUE

   ### setting argument
   expect_snapshot(
     objective$set_argument("a" = -2)
   )

   ### overwriting argument
   expect_error(
     objective$set_argument("a" = -3, .overwrite = FALSE),
     "already exists"
   )
   expect_snapshot(
     objective$set_argument("a" = -3)
   )

   ### getting argument
   expect_snapshot(
     objective$get_argument("a")
   )

   ### remove argument
   expect_snapshot(
     objective$remove_argument("a")
   )

   ### set argument again
   expect_snapshot(
     objective$set_argument("a" = -2)
   )

   ### set gradient
   expect_snapshot(
     objective$set_gradient(f_gradient)
   )

   ### set gradient
   expect_snapshot(
     objective$set_hessian(f_hessian)
   )

   ### synchronizing arguments for gradient and Hessian
   objective$remove_argument("a", .verbose = FALSE)
   expect_snapshot(
     objective$set_argument("a" = 1)
   )

})

test_that("objective fields can be accessed", {

  ### objective definition
  f <- function(x, a, b = 0) (x + a)^2 + b
  f_gradient <- function(x, a, b = 0) 2 * x + 2 * a
  f_hessian <- function(x, a, b = 0) 2
  objective <- Objective$new(f = f, npar = 1, "a" = 2)
  objective$verbose <- FALSE
  objective$
    set_gradient(f_gradient)$
    set_hessian(f_hessian)

  ### objective_name
  expect_equal(
    objective$objective_name,
    "f"
  )

  ### fixed_arguments
  expect_error(
    objective$fixed_arguments <- c("this", "that"),
    "read-only"
  )

  ### hide_warnings
  expect_false(
    objective$hide_warnings
  )
  objective$hide_warnings <- TRUE
  expect_true(
    objective$hide_warnings
  )

  ### npar
  expect_error(
    objective$npar <- 1,
    "read-only"
  )

  ### target
  expect_error(
    objective$target <- "y",
    "read-only"
  )

  ### gradient specified
  expect_true(
    objective$gradient_specified
  )
  expect_error(
    objective$gradient_specified <- FALSE,
    "read-only"
  )

  ### hessian specified
  expect_true(
    objective$hessian_specified
  )
  expect_error(
    objective$hessian_specified <- FALSE,
    "read-only"
  )

})

test_that("objective with one target argument can be evaluated", {

  ### objective definition
  f <- function(x, a, b = 0) (x + a)^2 + b
  objective <- Objective$new(f = f, npar = 1, a = -2)
  objective$verbose <- FALSE

  ### evaluations
  expect_equal(
    objective$get_argument("b"),
    0
  )
  expect_equal(
    objective$evaluate(2),
    0
  )
  expect_silent(
    objective$remove_argument("a")
  )
  expect_error(
    objective$evaluate(2),
    "is required but not specified yet"
  )
  expect_silent(
    objective$set_argument("a" = -2)
  )
  expect_error(
    objective$set_argument("a" = -2, .overwrite = FALSE),
    "already exists"
  )
  expect_silent(
    objective$set_argument("a" = -2, .overwrite = TRUE)
  )
  expect_equal(
    objective$evaluate(2),
    0
  )
  expect_snapshot(
    print(objective)
  )
  expect_equal(
    objective$fixed_arguments,
    c("b", "a")
  )
  expect_error(
    objective$evaluate_gradient(2),
    "Gradient function is required"
  )
  expect_error(
    objective$evaluate_hessian(2),
    "Hessian function is required"
  )
})

test_that("objective can be evaluated with a time limit", {
  skip_if_not(.Platform$OS.type == "windows")
  f <- function(x, a, b = 0) {
    Sys.sleep(2)
    (x + a)^2 + b
  }
  objective <- Objective$new(f = f, npar = 1, a = -2)
  objective$verbose <- FALSE
  objective$seconds <- 0.5
  expect_equal(
    objective$evaluate(1),
    "time limit reached"
  )
})

test_that("objective with more than one target argument can be evaluated", {
  llk <- function(mu, sd, lambda, data) {
    sd <- exp(sd)
    lambda <- plogis(lambda)
    sum(log(
      lambda * dnorm(data, mu[1], sd[1]) +
        (1 - lambda) * dnorm(data, mu[2], sd[2])
    ))
  }
  objective <- Objective$new(
    f = llk, target = c("mu", "sd", "lambda"), npar = c(2, 2, 1),
    data = faithful$eruptions
  )
  objective$verbose <- FALSE
  expect_equal(
    objective$get_argument("data"),
    faithful$eruptions
  )
  expect_snapshot(
    print(objective)
  )
  expect_equal(
    objective$evaluate(1:5),
    llk(mu = 1:2, sd = 3:4, lambda = 5, data = faithful$eruptions)
  )
  expect_equal(
    objective$evaluate(1:5, .negate = TRUE),
    -llk(mu = 1:2, sd = 3:4, lambda = 5, data = faithful$eruptions)
  )
})

test_that("objective with NULL argument can be evaluated", {
  f <- function(x, a, b, ind) {
    if (is.null(ind)) {
      (x[1]^2 + x[2] + a)^2 + (x[1] + x[2]^2 + b)^2 + (x[3] - 1)^2
    }
  }
  obj <- Objective$new(
    f = f,
    target = "x",
    npar = 3
  )
  expect_snapshot(
    print(obj)
  )
  obj$verbose <- FALSE
  checkmate::expect_number(
    obj$evaluate(.at = c(0, 0, 0), a = -11, b = -7, ind = NULL)
  )
  expect_null(
    obj$evaluate(.at = c(0, 0, 0), a = -11, b = -7, ind = TRUE)
  )
  obj$set_argument("a" = -11, "b" = -7, "ind" = NULL)
  checkmate::expect_number(
    obj$evaluate(.at = c(0, 0, 0))
  )
})

test_that("gradient and hessian can be specified and evaluated", {

  ### define objective
  himmelblau <- function(x) (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
  himmelblau_objective <- Objective$new(f = himmelblau, npar = 2)
  himmelblau_objective$verbose <- FALSE
  himmelblau_gradient <- function(x) {
    c(
      4 * x[1] * (x[1]^2 + x[2] - 11) + 2 * (x[1] + x[2]^2 - 7),
      2 * (x[1]^2 + x[2] - 11) + 4 * x[2] * (x[1] + x[2]^2 - 7)
    )
  }
  himmelblau_objective$set_gradient(himmelblau_gradient)

  ### evaluate
  expect_equal(
    himmelblau_objective$evaluate_gradient(c(3, 2)),
    himmelblau_gradient(c(3, 2))
  )
  himmelblau_hessian <- function(x) {
    matrix(
      c(
        12 * x[1]^2 + 4 * x[2] - 42, 4 * x[1] + 4 * x[2],
        4 * x[1] + 4 * x[2], 12 * x[2]^2 + 4 * x[1] - 26
      ),
      nrow = 2
    )
  }
  himmelblau_objective$set_hessian(himmelblau_hessian)
  expect_equal(
    himmelblau_objective$evaluate_hessian(c(3, 2)),
    himmelblau_hessian(c(3, 2))
  )

  ### values as attributes
  expect_identical(
    himmelblau_objective$evaluate(
      .at = c(1, 2),
      .negate = TRUE,
      .gradient_as_attribute = TRUE,
      .gradient_attribute_name = "gradient",
      .hessian_as_attribute = TRUE,
      .hessian_attribute_name = "hessian"
    ),
    structure(
      -68,
      gradient = c(36, 32),
      hessian = structure(c(22, -12, -12, -26), dim = c(2L, 2L))
    )
  )
})

test_that("numerical gradient and hessian can be calculated", {
  himmelblau <- function(x, a, b) (x[1]^2 + x[2] - a)^2 + (x[1] + x[2]^2 - b)^2
  himmelblau_gradient <- function(x, a, b) {
    c(
      4 * x[1] * (x[1]^2 + x[2] - a) + 2 * (x[1] + x[2]^2 - b),
      2 * (x[1]^2 + x[2] - a) + 4 * x[2] * (x[1] + x[2]^2 - b)
    )
  }
  himmelblau_hessian <- function(x, a, b) {
    matrix(
      c(
        12 * x[1]^2 + 4 * x[2] - 4 * a + 2, 4 * x[1] + 4 * x[2],
        4 * x[1] + 4 * x[2], 12 * x[2]^2 + 4 * x[1] - 4 * b + 2
      ),
      nrow = 2
    )
  }
  objective <- Objective$new(f = himmelblau, npar = 2, a = 11, b = 7)
  expect_equal(
    objective$evaluate_gradient_numeric(1:2),
    himmelblau_gradient(1:2, a = 11, b = 7)
  )
  expect_equal(
    objective$evaluate_hessian_numeric(1:2),
    himmelblau_hessian(1:2, a = 11, b = 7)
  )
})

test_that("invalid numerical derivatives return NA structures", {
  normal_mixture_llk <- function(mu, sigma, lambda, data) {
    sigma <- exp(sigma)
    lambda <- plogis(lambda)
    sum(log(
      lambda * dnorm(data, mu[1], sigma[1]) +
        (1 - lambda) * dnorm(data, mu[2], sigma[2])
    ))
  }
  objective <- Objective$new(
    f = normal_mixture_llk,
    target = c("mu", "sigma", "lambda"),
    npar = c(2, 2, 1),
    data = datasets::faithful$eruptions
  )
  bad <- c(-2L, -3L, -5L, -3L, -1L)

  expect_identical(
    objective$evaluate_gradient_numeric(.at = bad),
    rep(NA_real_, length(bad))
  )
  expect_identical(
    objective$evaluate_hessian_numeric(.at = bad),
    matrix(NA_real_, nrow = length(bad), ncol = length(bad))
  )
})

#' Specify numerical optimizer object
#'
#' @description
#' The \code{Optimizer} object defines a numerical optimizer based on any
#' optimization algorithm implemented in R. The main advantage of working with
#' an \code{Optimizer} object instead of using the optimization function
#' directly lies in the standardized inputs and outputs.
#'
#' Any R function that fulfills the following four constraints can be defined
#' as an \code{Optimizer} object:
#'
#' 1. It must have an input for a \code{function}, the objective function to be
#'    optimized.
#' 2. It must have an input for a \code{numeric} vector, the initial values
#'    where the optimizer starts.
#' 3. It must have a \code{...} argument for additional parameters passed on to
#'    the objective function.
#' 4. The output must be a named \code{list}, including the optimal function
#'    value and the optimal parameter vector.
#'
#' @param objective \[`function` | `Objective`\]\cr
#' A \code{function} to be optimized that
#'
#' 1. has at least one argument that receives a \code{numeric} \code{vector}
#' 2. and returns a single \code{numeric} value.
#'
#' Alternatively, it can also be an \code{\link{Objective}} object for more
#' flexibility.
#'
#' @param initial \[`numeric()`\]\cr
#' Starting parameter values for the optimization.
#'
#' @param lower \[`NA` | `numeric()` | `numeric(1)`\]\cr
#' Lower bounds on the parameters.
#'
#' If a single number, this will be applied to all parameters.
#'
#' Can be `NA` to not define any bounds.
#'
#' @param upper \[`NA` | `numeric()` | `numeric(1)`\]\cr
#' Upper bounds on the parameters.
#'
#' If a single number, this will be applied to all parameters.
#'
#' Can be `NA` to not define any bounds.
#'
#' @param ... \[`any`\]\cr
#' In \code{Optimizer$new()} and \code{$set_arguments()}, named arguments to
#' pass to the optimizer algorithm. In \code{$minimize()},
#' \code{$maximize()}, and \code{$optimize()}, named arguments to pass to the
#' objective function.
#'
#' @param direction \[`character(1)`\]\cr
#' Either `"min"` for minimization or `"max"` for maximization.
#'
#' @param .verbose \[`logical(1)`\]\cr
#' Print status messages?
#'
#' @examples
#' ### Task: compare minimization with 'stats::nlm' and 'pracma::nelder_mead'
#'
#' # 1. define objective function and initial values
#' objective <- TestFunctions::TF_ackley
#' initial <- c(3, 3)
#'
#' # 2. get overview of optimizers available in dictionary
#' optimizer_dictionary$keys
#'
#' # 3. define 'nlm' optimizer
#' nlm <- Optimizer$new(which = "stats::nlm")
#'
#' # 4. define the 'pracma::nelder_mead' optimizer
#' #    (not contained in the dictionary)
#' nelder_mead <- Optimizer$new(which = "custom")
#' nelder_mead$definition(
#'   algorithm = pracma::nelder_mead, # optimization function
#'   arg_objective = "fn",            # objective function argument name
#'   arg_initial = "x0",              # argument name for the initial values
#'   out_value = "fmin",              # element for the optimal function value
#'   out_parameter = "xmin",          # element for the optimal parameters
#'   direction = "min"                # optimizer minimizes
#' )
#'
#' # 5. compare the minimization results
#' nlm$minimize(objective, initial)
#' nelder_mead$minimize(objective, initial)
#'
#' @export

Optimizer <- R6::R6Class(

  classname = "Optimizer",

  public = list(

    #' @description
    #' Initializes a new \code{Optimizer} object.
    #'
    #' @param which \[`character(1)`\]\cr
    #' Either:
    #'
    #' - one of \code{optimizer_dictionary$keys}
    #' - or \code{"custom"}, in which case \code{$definition()} must be used to
    #' define the optimizer details.
    #'
    #' @return
    #' A new \code{Optimizer} object.

    initialize = function(which, ..., .verbose = TRUE) {

      ### input checks
      oeli::input_check_response(
        check = oeli::check_missing(which),
        var_name = "which"
      )
      oeli::input_check_response(
        check = checkmate::check_string(which),
        var_name = "which"
      )
      oeli::input_check_response(
        check = checkmate::check_flag(.verbose),
        var_name = ".verbose"
      )

      ### initialize optimizer
      if (identical(which, "custom")) {
        if (.verbose) {
          cli::cli_inform(
            "Use method {.fun $definition} next to define a custom optimizer."
          )
        }
      } else {
        oeli::input_check_response(
          check = checkmate::check_choice(
            which, choices = optimizer_dictionary$keys
          ),
          var_name = "which"
        )
        self$definition(
          algorithm = optimizer_dictionary$get(
            key = which, value = "algorithm"
          ),
          arg_objective = optimizer_dictionary$get(
            key = which, value = "arg_objective"
          ),
          arg_initial = optimizer_dictionary$get(
            key = which, value = "arg_initial"
          ),
          arg_lower = optimizer_dictionary$get(
            key = which, value = "arg_lower"
          ),
          arg_upper = optimizer_dictionary$get(
            key = which, value = "arg_upper"
          ),
          arg_gradient = optimizer_dictionary$get(
            key = which, value = "arg_gradient"
          ),
          arg_hessian = optimizer_dictionary$get(
            key = which, value = "arg_hessian"
          ),
          gradient_as_attribute = optimizer_dictionary$get(
            key = which, value = "gradient_as_attribute"
          ),
          hessian_as_attribute = optimizer_dictionary$get(
            key = which, value = "hessian_as_attribute"
          ),
          out_value = optimizer_dictionary$get(
            key = which, value = "out_value"
          ),
          out_parameter = optimizer_dictionary$get(
            key = which, value = "out_parameter"
          ),
          direction = optimizer_dictionary$get(
            key = which, value = "direction"
          )
        )
        self$label <- which
        self$set_arguments(...)
      }
    },

    #' @description
    #' Defines an optimizer.
    #'
    #' @param algorithm \[`function`\]\cr
    #' The optimization algorithm.
    #'
    #' @param arg_objective \[`character(1)`\]\cr
    #' The argument name for the objective function in \code{algorithm}.
    #'
    #' @param arg_initial \[`character(1)`\]\cr
    #' The argument name for the initial values in \code{algorithm}.
    #'
    #' @param arg_lower \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the lower parameter bound in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.
    #'
    #' @param arg_upper \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the upper parameter bound in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.
    #'
    #' @param arg_gradient \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the gradient function in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.
    #'
    #' @param arg_hessian \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the Hessian function in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.
    #'
    #' @param gradient_as_attribute \[`logical(1)`\]\cr
    #' Only relevant if `arg_gradient` is not `NA`.
    #'
    #' In that case, does `algorithm` expect that the gradient is an attribute
    #' of the objective function output (as for example in
    #' \code{\link[stats]{nlm}})? In that case, `arg_gradient` defines the
    #' attribute name.
    #'
    #' @param hessian_as_attribute \[`logical(1)`\]\cr
    #' Only relevant if `arg_hessian` is not `NA`.
    #'
    #' In that case, does `algorithm` expect that the Hessian is an attribute
    #' of the objective function output (as for example in
    #' \code{\link[stats]{nlm}})? In that case, `arg_hessian` defines the
    #' attribute name.
    #'
    #' @param out_value \[`character(1)`\]\cr
    #' The element name for the optimal function value in the output
    #' \code{list} of \code{algorithm}.
    #'
    #' @param out_parameter \[`character(1)`\]\cr
    #' The element name for the optimal parameters in the output \code{list} of
    #' \code{algorithm}.
    #'
    #' @param direction \[`character(1)`\]\cr
    #' Either \code{"min"} (if the optimizer minimizes) or \code{"max"}
    #' (if the optimizer maximizes).

    definition = function(
      algorithm,
      arg_objective,
      arg_initial,
      arg_lower = NA,
      arg_upper = NA,
      arg_gradient = NA,
      arg_hessian = NA,
      gradient_as_attribute = FALSE,
      hessian_as_attribute = FALSE,
      out_value,
      out_parameter,
      direction
    ) {

      oeli::input_check_response(
        check = oeli::check_missing(algorithm),
        var_name = "algorithm"
      )
      self$algorithm <- algorithm
      self$label <- oeli::variable_name(algorithm)

      oeli::input_check_response(
        check = oeli::check_missing(arg_objective),
        var_name = "arg_objective"
      )
      self$arg_objective <- arg_objective

      oeli::input_check_response(
        check = oeli::check_missing(arg_initial),
        var_name = "arg_initial"
      )
      self$arg_initial <- arg_initial

      self$arg_lower <- arg_lower
      self$arg_upper <- arg_upper
      self$arg_gradient <- arg_gradient
      self$arg_hessian <- arg_hessian
      self$gradient_as_attribute <- gradient_as_attribute
      self$hessian_as_attribute <- hessian_as_attribute

      oeli::input_check_response(
        check = oeli::check_missing(out_value),
        var_name = "out_value"
      )
      self$out_value <- out_value

      oeli::input_check_response(
        check = oeli::check_missing(out_parameter),
        var_name = "out_parameter"
      )
      self$out_parameter <- out_parameter

      oeli::input_check_response(
        check = oeli::check_missing(direction),
        var_name = "direction"
      )
      self$direction <- direction

      oeli::input_check_response(
        check = checkmate::check_function(
          algorithm,
          args = c(
            arg_objective, self$arg_initial,
            if (!is.na(arg_lower)) arg_lower, if (!is.na(arg_upper)) arg_upper,
            if (
              !is.na(arg_gradient) && isFALSE(gradient_as_attribute)
            ) arg_gradient,
            if (
              !is.na(arg_hessian) && isFALSE(hessian_as_attribute)
            ) arg_hessian,
            "..."
          )
        ),
        var_name = "algorithm"
      )

      invisible(self)
    },

    #' @description
    #' Sets optimizer arguments.
    #'
    #' @return
    #' The \code{Optimizer} object.

    set_arguments = function(...) {
      arguments <- list(...)
      private$.arguments[names(arguments)] <- arguments
    },

    #' @description
    #' Perform minimization.
    #'
    #' @return
    #' A named \code{list}, containing at least these five elements:
    #' \describe{
    #'   \item{\code{value}}{A \code{numeric}, the minimum function value.}
    #'   \item{\code{parameter}}{A \code{numeric} vector, the parameter vector
    #'   where the minimum is obtained.}
    #'   \item{\code{seconds}}{A \code{numeric}, the optimization time in
    #'   seconds.}
    #'   \item{\code{initial}}{A \code{numeric}, the initial parameter values.}
    #'   \item{\code{error}}{A \code{logical} flag: \code{TRUE} if an error
    #'   occurred, otherwise \code{FALSE}.}
    #' }
    #' Additional output elements from the optimizer are appended.
    #'
    #' If an error occurred, the error message is also appended as element
    #' \code{error_message}.
    #'
    #' If the time limit was exceeded, this counts as an error. In addition,
    #' the flag \code{time_out = TRUE} is appended.
    #'
    #' @examples
    #' Optimizer$new("stats::nlm")$
    #'   minimize(objective = function(x) x^4 + 3*x - 5, initial = 2)

    minimize = function(
      objective,
      initial,
      lower = NA,
      upper = NA,
      ...
    ) {
      oeli::input_check_response(
        check = oeli::check_missing(objective),
        var_name = "objective"
      )
      oeli::input_check_response(
        check = oeli::check_missing(initial),
        var_name = "initial"
      )
      private$.optimize(
        objective = objective,
        initial = initial,
        lower = lower,
        upper = upper,
        additional_arguments = list(...),
        direction = "min"
      )
    },

    #' @description
    #' Perform maximization.
    #'
    #' @return
    #' A named \code{list}, containing at least these five elements:
    #' \describe{
    #'   \item{\code{value}}{A \code{numeric}, the maximum function value.}
    #'   \item{\code{parameter}}{A \code{numeric} vector, the parameter vector
    #'   where the maximum is obtained.}
    #'   \item{\code{seconds}}{A \code{numeric}, the optimization time in
    #'   seconds.}
    #'   \item{\code{initial}}{A \code{numeric}, the initial parameter values.}
    #'   \item{\code{error}}{A \code{logical} flag: \code{TRUE} if an error
    #'   occurred, otherwise \code{FALSE}.}
    #' }
    #' Additional output elements from the optimizer are appended.
    #'
    #' If an error occurred, the error message is also appended as element
    #' \code{error_message}.
    #'
    #' If the time limit was exceeded, this also counts as an error. In
    #' addition, the flag \code{time_out = TRUE} is appended.
    #'
    #' @examples
    #' Optimizer$new("stats::nlm")$
    #'   maximize(objective = function(x) -x^4 + 3*x - 5, initial = 2)

    maximize = function(
      objective,
      initial,
      lower = NA,
      upper = NA,
      ...
    ) {
      oeli::input_check_response(
        check = oeli::check_missing(objective),
        var_name = "objective"
      )
      oeli::input_check_response(
        check = oeli::check_missing(initial),
        var_name = "initial"
      )
      private$.optimize(
        objective = objective,
        initial = initial,
        lower = lower,
        upper = upper,
        additional_arguments = list(...),
        direction = "max"
      )
    },

    #' @description
    #' Perform minimization or maximization.
    #'
    #' @return
    #' A named \code{list}, containing at least these five elements:
    #' \describe{
    #'   \item{\code{value}}{A \code{numeric}, the optimized function value.}
    #'   \item{\code{parameter}}{A \code{numeric} vector, the parameter vector
    #'   where the optimum is obtained.}
    #'   \item{\code{seconds}}{A \code{numeric}, the optimization time in
    #'   seconds.}
    #'   \item{\code{initial}}{A \code{numeric}, the initial parameter values.}
    #'   \item{\code{error}}{A \code{logical} flag: \code{TRUE} if an error
    #'   occurred, otherwise \code{FALSE}.}
    #' }
    #' Additional output elements from the optimizer are appended.
    #'
    #' If an error occurred, the error message is also appended as element
    #' \code{error_message}.
    #'
    #' If the time limit was exceeded, this also counts as an error. In
    #' addition, the flag \code{time_out = TRUE} is appended.
    #'
    #' @examples
    #' objective <- function(x) -x^4 + 3*x - 5
    #' optimizer <- Optimizer$new("stats::nlm")
    #' optimizer$optimize(
    #'   objective = objective, initial = 2, direction = "min"
    #' )
    #' optimizer$optimize(
    #'   objective = objective, initial = 2, direction = "max"
    #' )

    optimize = function(
      objective,
      initial,
      lower = NA,
      upper = NA,
      direction = "min",
      ...
    ) {
      oeli::input_check_response(
        check = oeli::check_missing(objective),
        var_name = "objective"
      )
      oeli::input_check_response(
        check = oeli::check_missing(initial),
        var_name = "initial"
      )
      private$.optimize(
        objective = objective,
        initial = initial,
        lower = lower,
        upper = upper,
        additional_arguments = list(...),
        direction = direction
      )
    },

    #' @description
    #' Prints the optimizer label.
    #' @return
    #' Invisibly the \code{Optimizer} object.

    print = function(...) {
      cat("<optimizer '", self$label, "'>", sep = "")
      invisible(self)
    }

  ),

  active = list(

    #' @field label \[`character(1)`\]\cr
    #' The label for the optimizer.

    label = function(value) {
      if (missing(value)) {
        private$.label
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value)
        )
        private$.label <- value
      }
    },

    #' @field algorithm \[`function`\]\cr
    #' The optimization algorithm.

    algorithm = function(value) {
      if (missing(value)) {
        private$.algorithm
      } else {
        oeli::input_check_response(
          check = checkmate::check_function(value)
        )
        private$.algorithm <- value
      }
    },

    #' @field arg_objective \[`character(1)`\]\cr
    #' The argument name for the objective function in \code{algorithm}.

    arg_objective = function(value) {
      if (missing(value)) {
        private$.arg_objective
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value)
        )
        private$.arg_objective <- value
      }
    },

    #' @field arg_initial \[`character(1)`\]\cr
    #' The argument name for the initial values in \code{algorithm}.

    arg_initial = function(value) {
      if (missing(value)) {
        private$.arg_initial
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value)
        )
        private$.arg_initial <- value
      }
    },

    #' @field arg_lower \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the lower parameter bound in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.

    arg_lower = function(value) {
      if (missing(value)) {
        private$.arg_lower
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value, na.ok = TRUE)
        )
        private$.arg_lower <- value
      }
    },

    #' @field arg_upper \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the upper parameter bound in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.

    arg_upper = function(value) {
      if (missing(value)) {
        private$.arg_upper
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value, na.ok = TRUE)
        )
        private$.arg_upper <- value
      }
    },

    #' @field arg_gradient \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the gradient function in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.

    arg_gradient = function(value) {
      if (missing(value)) {
        private$.arg_gradient
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value, na.ok = TRUE)
        )
        private$.arg_gradient <- value
      }
    },

    #' @field arg_hessian \[`character(1)` | `NA`\]\cr
    #' Optionally the argument name for the Hessian function in
    #' \code{algorithm}.
    #'
    #' Can be `NA` if not available.

    arg_hessian = function(value) {
      if (missing(value)) {
        private$.arg_hessian
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value, na.ok = TRUE)
        )
        private$.arg_hessian <- value
      }
    },

    #' @field gradient_as_attribute \[`logical(1)`\]\cr
    #' Only relevant if `arg_gradient` is not `NA`.
    #'
    #' In that case, does `algorithm` expect that the gradient is an attribute
    #' of the objective function output (as for example in
    #' \code{\link[stats]{nlm}})? In that case, `arg_gradient` defines the
    #' attribute name.

    gradient_as_attribute = function(value) {
      if (missing(value)) {
        private$.gradient_as_attribute
      } else {
        oeli::input_check_response(
          check = checkmate::check_flag(value)
        )
        private$.gradient_as_attribute <- value
      }
    },

    #' @field hessian_as_attribute \[`logical(1)`\]\cr
    #' Only relevant if `arg_hessian` is not `NA`.
    #'
    #' In that case, does `algorithm` expect that the Hessian is an attribute
    #' of the objective function output (as for example in
    #' \code{\link[stats]{nlm}})? In that case, `arg_hessian` defines the
    #' attribute name.

    hessian_as_attribute = function(value) {
      if (missing(value)) {
        private$.hessian_as_attribute
      } else {
        oeli::input_check_response(
          check = checkmate::check_flag(value)
        )
        private$.hessian_as_attribute <- value
      }
    },

    #' @field out_value \[`character(1)`\]\cr
    #' The element name for the optimal function value in the output
    #' \code{list} of \code{algorithm}.

    out_value = function(value) {
      if (missing(value)) {
        private$.out_value
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value)
        )
        private$.out_value <- value
      }
    },

    #' @field out_parameter \[`character(1)`\]\cr
    #' The element name for the optimal parameters in the output \code{list} of
    #' \code{algorithm}.

    out_parameter = function(value) {
      if (missing(value)) {
        private$.out_parameter
      } else {
        oeli::input_check_response(
          check = checkmate::check_string(value)
        )
        private$.out_parameter <- value
      }
    },

    #' @field direction \[`character(1)`\]\cr
    #' Either \code{"min"} (if the optimizer minimizes) or \code{"max"}
    #' (if the optimizer maximizes).

    direction = function(value) {
      if (missing(value)) {
        private$.direction
      } else {
        oeli::input_check_response(
          check = checkmate::check_choice(value, c("min", "max"))
        )
        private$.direction <- value
      }
    },

    #' @field arguments \[`list()`\]\cr
    #' Custom arguments for \code{algorithm}.
    #'
    #' Defaults are used for arguments that are not specified.

    arguments = function(value) {
      if (missing(value)) {
        private$.arguments
      } else {
        oeli::input_check_response(
          check = checkmate::check_list(value, names = "unique")
        )
        private$.arguments <- value
      }
    },

    #' @field seconds \[`numeric(1)`\]\cr
    #' A time limit in seconds.
    #'
    #' Optimization is interrupted prematurely if \code{seconds} is exceeded.
    #'
    #' No time limit if \code{seconds = Inf} (the default).
    #'
    #' Note the limitations documented in \code{\link[base]{setTimeLimit}}.

    seconds = function(value) {
      if (missing(value)) {
        private$.seconds
      } else {
        oeli::input_check_response(
          check = checkmate::check_number(value, lower = 0, finite = FALSE)
        )
        private$.seconds <- value
      }
    },

    #' @field hide_warnings \[`logical(1)`\]\cr
    #' Hide warnings during optimization?

    hide_warnings = function(value) {
      if (missing(value)) {
        private$.hide_warnings
      } else {
        oeli::input_check_response(
          check = checkmate::check_flag(value)
        )
        private$.hide_warnings <- value
      }
    },

    #' @field output_ignore \[`character()`\]\cr
    #' Elements to ignore (not include) in the optimization output.

    output_ignore = function(value) {
      if (missing(value)) {
        private$.output_ignore
      } else {
        oeli::input_check_response(
          check = checkmate::check_names(value)
        )
        private$.output_ignore <- value
      }
    }
  ),

  private = list(

    .label = "unlabeled",
    .algorithm = NULL,
    .arg_objective = NULL,
    .arg_initial = NULL,
    .arg_lower = NULL,
    .arg_upper = NULL,
    .arg_gradient = NULL,
    .arg_hessian = NULL,
    .gradient_as_attribute = NULL,
    .hessian_as_attribute = NULL,
    .out_value = NULL,
    .out_parameter = NULL,
    .direction = NULL,
    .arguments = list(),
    .seconds = Inf,
    .hide_warnings = FALSE,
    .output_ignore = character(),

    ### helper function that prepares the optimization results
    .prepare_result = function(result, initial, invert_objective) {
      oeli::input_check_response(
        check = checkmate::check_list(result$result),
        prefix = "The optimizer output is bad:"
      )
      out <- list()
      if (private$.out_value %in% names(result$result)) {
        if (invert_objective) {
          out[["value"]] <- -result$result[[private$.out_value]]
        } else {
          out[["value"]] <- result$result[[private$.out_value]]
        }
      } else {
        out[["value"]] <- NA_real_
      }
      if (private$.out_parameter %in% names(result$result)) {
        out[["parameter"]] <- result$result[[private$.out_parameter]]
      } else {
        out[["parameter"]] <- rep(NA_real_, length(initial))
      }
      if ("time" %in% names(result)) {
        out[["seconds"]] <- as.numeric(result$time)
      } else {
        out[["seconds"]] <- NA_real_
      }
      out[["initial"]] <- initial
      if (!"error" %in% names(result)) {
        out[["error"]] <- FALSE
      } else {
        out[["error"]] <- TRUE
      }
      not_add <- c(
        private$.output_ignore,
        private$.out_value,
        private$.out_parameter
      )
      oeli::merge_lists(
        out,
        result$result[!names(result$result) %in% not_add]
      )
    },

    ### helper function that build an 'Objective' object from a function
    .build_objective_object = function(objective, initial) {
      if (!checkmate::test_r6(objective, "Objective")) {
        oeli::input_check_response(
          check = oeli::check_numeric_vector(initial),
          var_name = "initial"
        )
        objective <- Objective$new(
          f = objective,
          target = names(formals(objective))[1],
          npar = length(initial)
        )
      }
      return(objective)
    },

    ### helper function that performs optimization
    .optimize = function(
      objective, initial, lower, upper, additional_arguments, direction
    ) {

      ### input checks
      oeli::input_check_response(
        check = checkmate::check_choice(direction, c("min", "max")),
        var_name = "direction"
      )
      checkmate::assert_list(additional_arguments) # to make sure

      ### build objective function
      objective_object <- private$.build_objective_object(objective, initial)

      ### check parameter bounds
      parameter_bounds_arguments <- list()
      if (!checkmate::test_scalar_na(lower)) {
        if (!is.na(self$arg_lower)) {
          if (checkmate::test_number(lower)) {
            lower <- rep(lower, length(initial))
          }
          oeli::input_check_response(
            check = oeli::check_numeric_vector(
              lower, len = length(initial), any.missing = FALSE
            ),
            var_name = "lower"
          )
          parameter_bounds_arguments <- c(
            parameter_bounds_arguments,
            structure(
              list(lower), names = self$arg_lower
            )
          )
        } else {
          if (!self$hide_warnings) {
            cli::cli_warn(
              "The optimizer does not support lower parameter bounds."
            )
          }
          lower <- NA
        }
      }
      if (!checkmate::test_scalar_na(upper)) {
        if (!is.na(self$arg_upper)) {
          if (checkmate::test_number(upper)) {
            upper <- rep(upper, length(initial))
          }
          oeli::input_check_response(
            check = oeli::check_numeric_vector(
              upper, len = length(initial), any.missing = FALSE
            ),
            "upper"
          )
          parameter_bounds_arguments <- c(
            parameter_bounds_arguments,
            structure(
              list(upper), names = self$arg_upper
            )
          )
        } else {
          if (!self$hide_warnings) {
            cli::cli_warn(
              "The optimizer does not support upper parameter bounds."
            )
          }
          upper <- NA
        }
      }

      ### build objective, gradient, and Hessian wrappers
      invert_objective <- !identical(private$.direction, direction)
      evaluate_arguments <- function(.at) {
        c(
          list(
            ".at" = .at,
            ".negate" = invert_objective
          ),
          additional_arguments
        )
      }
      objective_function <- function(.at, ...) {
        do.call(
          what = objective_object$evaluate,
          args = c(
            evaluate_arguments(.at),
            list(
              ".gradient_as_attribute" = self$gradient_as_attribute,
              ".gradient_attribute_name" = self$arg_gradient,
              ".hessian_as_attribute" = self$hessian_as_attribute,
              ".hessian_attribute_name" = self$arg_hessian
            )
          )
        )
      }
      gradient_function <- function(.at, ...) {
        do.call(
          what = objective_object$evaluate_gradient,
          args = evaluate_arguments(.at)
        )
      }
      hessian_function <- function(.at, ...) {
        do.call(
          what = objective_object$evaluate_hessian,
          args = evaluate_arguments(.at)
        )
      }

      ### build gradient and hessian arguments
      gradient_hessian_arguments <- list()
      if (objective_object$gradient_specified && !self$gradient_as_attribute) {
        if (!is.na(self$arg_gradient)) {
          gradient_hessian_arguments <- c(
            gradient_hessian_arguments,
            structure(
              list(gradient_function),
              names = self$arg_gradient
            )
          )
        } else {
          if (!self$hide_warnings) {
            cli::cli_warn(
              "The optimizer does not support custom gradient function."
            )
          }
        }
      }
      if (objective_object$hessian_specified && !self$hessian_as_attribute) {
        if (!is.na(self$arg_hessian)) {
          gradient_hessian_arguments <- c(
            gradient_hessian_arguments,
            structure(
              list(hessian_function),
              names = self$arg_hessian
            )
          )
        } else {
          if (!self$hide_warnings) {
            cli::cli_warn(
              "The optimizer does not support custom Hessian function."
            )
          }
        }
      }

      ### build optimizer arguments
      args <- c(
        ### defines objective and initial argument for optimizer
        structure(
          list(objective_function, initial),
          names = c(private$.arg_objective, private$.arg_initial)
        ),

        ### optimizer arguments have priority over internal helper arguments
        oeli::merge_lists(
          parameter_bounds_arguments,
          gradient_hessian_arguments,
          private$.arguments
        )
      )
      checkmate::assert_list(args, names = "unique") # to make sure

      ### optimize
      result <- tryCatch(
        {
          suppressWarnings(
            oeli::timed(
              oeli::do.call_timed(
                what = private$.algorithm,
                args = args,
                units = "secs"
              ),
              seconds = private$.seconds,
              on_time_out = "error"
            ),
            classes = if (private$.hide_warnings) "warning" else ""
          )
        },
        error = function(e) {
          error_message <- e$message
          time_out <- grepl("time limit exceeded", error_message)
          if (time_out) {
            list(
              "result" = list(
                "error_message" = error_message,
                "time_out" = TRUE
              ),
              "error" = TRUE,
              "time" = NA_real_
            )
          } else {
            list(
              "result" = list("error_message" = error_message),
              "error" = TRUE,
              "time" = NA_real_
            )
          }
        }
      )

      ### prepare result
      private$.prepare_result(result, initial, invert_objective)
    }

  )

)

test_that("optimizer object exceptions can be detected", {

  ### test bad output
  bad_output_opt <- Optimizer$new("custom", .verbose = FALSE)$
    definition(
      algorithm = function(f, x, ...) 1,
      arg_objective = "f",
      arg_initial = "x",
      out_value = "value",
      out_parameter = "parameter",
      direction = "min"
    )

  ### test error
  error_opt <- Optimizer$new("custom", .verbose = FALSE)$
    definition(
      algorithm = function(f, p, ...) {
        if (identical(p, 1:2)) stop("error message")
        list(v = f(p), z = 1:2)
      },
      arg_objective = "f",
      arg_initial = "p",
      out_value = "v",
      out_parameter = "z",
      direction = "min"
    )
  out <- error_opt$
    minimize(objective = TestFunctions::TF_ackley, initial = 1:2)
  expect_true(out$error)
  expect_equal(out$error_message, "error message")

  ### test time out
  skip_if_not(.Platform$OS.type == "windows")
  slow_opt <- Optimizer$new("custom", .verbose = FALSE)$
    definition(
      algorithm = function(f, p, ...) {
        Sys.sleep(2)
        stats::nlm(f = f, p = p)
      },
      arg_objective = "f",
      arg_initial = "p",
      out_value = "v",
      out_parameter = "z",
      direction = "min"
    )
  slow_opt$seconds <- 1
  out <- slow_opt$
    minimize(objective = TestFunctions::TF_ackley, initial = 1:2)
  expect_true(out$error)
  expect_equal(out$error_message, "time limit exceeded")
})

test_that("simple minimization works", {
  objective <- function(x) x^2
  opt_nlm <- Optimizer$new("stats::nlm")
  expect_snapshot(
    print(opt_nlm)
  )
  out <- opt_nlm$minimize(objective, initial = 2)
  expect_type(
    out,
    "list"
  )
  expect_named(
    out,
    c(
      "value", "parameter", "seconds", "initial",
      "error", "gradient", "code", "iterations"
    )
  )
})

test_that("simple maximization works", {
  objective <- function(x) -x^2
  out <- Optimizer$new("stats::nlm")$
    maximize(objective, initial = 2)
  expect_type(
    out,
    "list"
  )
  expect_named(
    out,
    c(
      "value", "parameter", "seconds", "initial",
      "error", "gradient", "code", "iterations"
    )
  )
})

test_that("minimization with additional arguments works", {
  objective <- function(x, a = 1) x^2 + a
  out <- Optimizer$new("stats::nlm")$
    minimize(objective, initial = 2, "a" = 10)
  expect_type(
    out,
    "list"
  )
  expect_named(
    out,
    c(
      "value", "parameter", "seconds", "initial",
      "error", "gradient", "code", "iterations"
    )
  )
})

test_that("call-time arguments are passed only to the objective", {
  seen <- new.env(parent = emptyenv())
  objective <- function(x, control, for_f) {
    seen$control <- control
    seen$for_f <- for_f
    sum(x^2)
  }

  expect_warning(
    out <- Optimizer$new("stats::optim")$minimize(
      objective = objective,
      initial = 1:3,
      control = list("something" = 1),
      for_f = "hi"
    ),
    NA
  )
  expect_false(out$error)
  expect_identical(seen$control, list("something" = 1))
  expect_identical(seen$for_f, "hi")
})

test_that("fixed argument that is NULL can be passed", {
  f <- function(x, a, b, ind) {
    if (is.null(ind)) {
      (x[1]^2 + x[2] + a)^2 + (x[1] + x[2]^2 + b)^2 + (x[3] - 1)^2
    }
  }
  expect_false(
    Optimizer$new("stats::nlm")$minimize(
      objective = f,
      initial = c(0, 0, 0),
      a = -11, b = -7, ind = NULL
    )$error
  )
})

test_that("parameter bounds can be used", {

  ### objective definition
  himmelblau_modified <- function(x) {
    if (abs(x[1]) > 5 || abs(x[2]) > 5) {
      -100
    } else {
      (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
    }
  }

  ### optimizer definition
  optim_opt <- Optimizer$new("stats::optim", method = "L-BFGS-B")

  ### minimization with bounds
  out <- optim_opt$minimize(
    objective = himmelblau_modified,
    initial = c(-10, -10),
    lower = -5,
    upper = 5
  )
  expect_true(
    all(abs(out$parameter) < 5)
  )

  ### minimization without bounds
  out <- optim_opt$minimize(
    objective = himmelblau_modified,
    initial = c(-10, -10)
  )
  expect_equal(out$value, -100)

  ### warning if optimizer does not support bounds
  nlm_opt <- Optimizer$new("stats::nlm")
  expect_warning(
    nlm_opt$minimize(
      objective = himmelblau_modified,
      initial = c(-10, -10),
      lower = -5
    ),
    "The optimizer does not support lower parameter bounds."
  )
  expect_warning(
    nlm_opt$minimize(
      objective = himmelblau_modified,
      initial = c(-10, -10),
      upper = -5
    ),
    "The optimizer does not support upper parameter bounds."
  )

})

test_that("gradient and hessian can be used", {

  ### objective definition with gradient and Hessian
  himmelblau <- function(x) (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
  himmelblau_gradient <- function(x) {
    # warning("gradient is used")
    c(
      4 * x[1] * (x[1]^2 + x[2] - 11) + 2 * (x[1] + x[2]^2 - 7),
      2 * (x[1]^2 + x[2] - 11) + 4 * x[2] * (x[1] + x[2]^2 - 7)
    )
  }
  himmelblau_hessian <- function(x) {
    # warning("hessian is used")
    matrix(
      c(
        12 * x[1]^2 + 4 * x[2] - 42, 4 * x[1] + 4 * x[2],
        4 * x[1] + 4 * x[2], 12 * x[2]^2 + 4 * x[1] - 26
      ),
      nrow = 2
    )
  }
  himmelblau_objective <- Objective$
    new(f = himmelblau, target = "x", npar = 2)$
    set_gradient(himmelblau_gradient, .verbose = FALSE)$
    set_hessian(himmelblau_hessian, .verbose = FALSE)

  ### using gradient and Hessian via attribute
  nlm_opt <- Optimizer$new("stats::nlm")
  out <- nlm_opt$optimize(
    objective = himmelblau_objective,
    initial = c(1, 2)
  )
  expect_false(out$error)

  ### using gradient and Hessian via argument
  nlminb_opt <- Optimizer$new("stats::nlminb")
  out <- nlminb_opt$optimize(
    objective = himmelblau_objective,
    initial = c(1, 2)
  )
  expect_false(out$error)

  ### using gradient and Hessian via argument but Hessian cannot be used
  optim_opt <- Optimizer$new("stats::optim", method = "BFGS")
  expect_warning(
    out <- optim_opt$optimize(
      objective = himmelblau_objective,
      initial = c(1, 2)
    ),
    "The optimizer does not support custom Hessian function."
  )
  expect_false(out$error)
})

#' @inherit Optimizer examples
#' @keywords internal
"_PACKAGE"

## usethis namespace: start
#' @importFrom checkmate assert_choice
#' @importFrom checkmate assert_flag
#' @importFrom checkmate assert_function
#' @importFrom checkmate assert_list
#' @importFrom checkmate assert_string
#' @importFrom checkmate check_character
#' @importFrom checkmate check_choice
#' @importFrom checkmate check_flag
#' @importFrom checkmate check_function
#' @importFrom checkmate check_integerish
#' @importFrom checkmate check_list
#' @importFrom checkmate check_names
#' @importFrom checkmate check_number
#' @importFrom checkmate check_string
#' @importFrom checkmate test_choice
#' @importFrom checkmate test_list
#' @importFrom checkmate test_number
#' @importFrom checkmate test_numeric
#' @importFrom checkmate test_r6
#' @importFrom checkmate test_scalar_na
#' @importFrom cli cat_bullet
#' @importFrom cli cli_abort
#' @importFrom cli cli_alert
#' @importFrom cli cli_alert_success
#' @importFrom cli cli_h1
#' @importFrom cli cli_h3
#' @importFrom cli cli_inform
#' @importFrom cli cli_warn
#' @importFrom lbfgsb3c lbfgsb3
#' @importFrom lbfgsb3c lbfgsb3c
#' @importFrom lbfgsb3c lbfgsb3f
#' @importFrom lbfgsb3c lbfgsb3x
#' @importFrom numDeriv grad
#' @importFrom numDeriv hessian
#' @importFrom oeli check_missing
#' @importFrom oeli check_numeric_vector
#' @importFrom oeli Dictionary
#' @importFrom oeli do.call_timed
#' @importFrom oeli function_arguments
#' @importFrom oeli function_body
#' @importFrom oeli function_defaults
#' @importFrom oeli input_check_response
#' @importFrom oeli merge_lists
#' @importFrom oeli test_numeric_vector
#' @importFrom oeli timed
#' @importFrom oeli variable_name
#' @importFrom pracma nelder_mead
#' @importFrom R6 R6Class
#' @importFrom stats nlm
#' @importFrom stats nlminb
#' @importFrom stats optim
#' @importFrom TestFunctions TF_ackley
#' @importFrom ucminf ucminf
## usethis namespace: end
NULL

# Gaussian mixture model parameter spaces work

    Code
      print(normal_mixture_spaces, show_transformer = TRUE)
    Message
      
      -- Optimization Space <numeric(5)> ---------------------------------------------
    Output
                   
       [1:2] mu    
       [3:4] sd    
       [5:5] lambda
    Message
      
      -- Transformation to Interpretation Space: 
    Output
                                         
       mu     x                          
       sd     exp(x)                     
       lambda c(plogis(x), 1 - plogis(x))
    Message
      
      -- Interpretation Space <list(3)> ----------------------------------------------
    Output
                   
       [[1]] mu    
       [[2]] sd    
       [[3]] lambda
    Message
      
      -- Transformation to Optimization Space: 
    Output
                          
       mu     x           
       sd     log(x)      
       lambda qlogis(x[1])
      

# Probit parameter spaces work

    Code
      print(probit_parameter, TRUE)
    Message
      
      -- Optimization Space <numeric(12)> --------------------------------------------
    Output
                    
       [1:3]   b    
       [4:9]   Omega
       [10:12] Sigma
    Message
      
      -- Transformation to Interpretation Space: 
    Output
                                                   
       b     x                                     
       Omega oeli::chol_to_cov(x)                  
       Sigma oeli::undiff_cov(oeli::chol_to_cov(x))
    Message
      
      -- Interpretation Space <list(3)> ----------------------------------------------
    Output
                  
       [[1]] b    
       [[2]] Omega
       [[3]] Sigma
    Message
      
      -- Transformation to Optimization Space: 
    Output
                                                 
       b     as.vector(x)                        
       Omega oeli::cov_to_chol(x)                
       Sigma oeli::cov_to_chol(oeli::diff_cov(x))
      

# Parameter spaces with zero length parameter work

    Code
      print(zero_parameter_spaces, show_transformer = TRUE)
    Message
      
      -- Optimization Space <numeric(2)> ---------------------------------------------
    Output
               
       [1:1]  x
       [NULL] y
       [2:2]  z
    Message
      
      -- Transformation to Interpretation Space: 
    Output
                    
       x x          
       y c("A", "B")
       z x          
    Message
      
      -- Interpretation Space <list(3)> ----------------------------------------------
    Output
              
       [[1]] x
       [[2]] y
       [[3]] z
    Message
      
      -- Transformation to Optimization Space: 
    Output
                     
       x as.vector(x)
       y c()         
       z as.vector(x)
      

# test various cli messages [plain]

    Code
      objective$set_argument(a = -2)
    Message
      > Setting argument "a".

---

    Code
      objective$set_argument(a = -3)
    Message
      > Overwriting argument "a".

---

    Code
      objective$get_argument("a")
    Message
      v Required argument "a" is specified.
      > Returning argument "a".
    Output
      [1] -3

---

    Code
      objective$remove_argument("a")
    Message
      v Required argument "a" is specified.
      > Removing argument "a".

---

    Code
      objective$set_argument(a = -2)
    Message
      > Setting argument "a".

---

    Code
      objective$set_gradient(f_gradient)
    Message
      > Setting gradient function.

---

    Code
      objective$set_hessian(f_hessian)
    Message
      > Setting Hessian function.

---

    Code
      objective$set_argument(a = 1)
    Message
      > Setting argument "a".
      > Synchronized arguments with gradient function.
      > Synchronized arguments with Hessian function.

# test various cli messages [ansi]

    Code
      objective$set_argument(a = -2)
    Message
      > Setting argument [34m[34m"a"[34m[39m.

---

    Code
      objective$set_argument(a = -3)
    Message
      > Overwriting argument [34m[34m"a"[34m[39m.

---

    Code
      objective$get_argument("a")
    Message
      [32mv[39m Required argument [34m[34m"a"[34m[39m is specified.
      > Returning argument [34m[34m"a"[34m[39m.
    Output
      [1] -3

---

    Code
      objective$remove_argument("a")
    Message
      [32mv[39m Required argument [34m[34m"a"[34m[39m is specified.
      > Removing argument [34m[34m"a"[34m[39m.

---

    Code
      objective$set_argument(a = -2)
    Message
      > Setting argument [34m[34m"a"[34m[39m.

---

    Code
      objective$set_gradient(f_gradient)
    Message
      > Setting gradient function.

---

    Code
      objective$set_hessian(f_hessian)
    Message
      > Setting Hessian function.

---

    Code
      objective$set_argument(a = 1)
    Message
      > Setting argument [34m[34m"a"[34m[39m.
      > Synchronized arguments with gradient function.
      > Synchronized arguments with Hessian function.

# test various cli messages [unicode]

    Code
      objective$set_argument(a = -2)
    Message
      → Setting argument "a".

---

    Code
      objective$set_argument(a = -3)
    Message
      → Overwriting argument "a".

---

    Code
      objective$get_argument("a")
    Message
      ✔ Required argument "a" is specified.
      → Returning argument "a".
    Output
      [1] -3

---

    Code
      objective$remove_argument("a")
    Message
      ✔ Required argument "a" is specified.
      → Removing argument "a".

---

    Code
      objective$set_argument(a = -2)
    Message
      → Setting argument "a".

---

    Code
      objective$set_gradient(f_gradient)
    Message
      → Setting gradient function.

---

    Code
      objective$set_hessian(f_hessian)
    Message
      → Setting Hessian function.

---

    Code
      objective$set_argument(a = 1)
    Message
      → Setting argument "a".
      → Synchronized arguments with gradient function.
      → Synchronized arguments with Hessian function.

# test various cli messages [fancy]

    Code
      objective$set_argument(a = -2)
    Message
      → Setting argument [34m[34m"a"[34m[39m.

---

    Code
      objective$set_argument(a = -3)
    Message
      → Overwriting argument [34m[34m"a"[34m[39m.

---

    Code
      objective$get_argument("a")
    Message
      [32m✔[39m Required argument [34m[34m"a"[34m[39m is specified.
      → Returning argument [34m[34m"a"[34m[39m.
    Output
      [1] -3

---

    Code
      objective$remove_argument("a")
    Message
      [32m✔[39m Required argument [34m[34m"a"[34m[39m is specified.
      → Removing argument [34m[34m"a"[34m[39m.

---

    Code
      objective$set_argument(a = -2)
    Message
      → Setting argument [34m[34m"a"[34m[39m.

---

    Code
      objective$set_gradient(f_gradient)
    Message
      → Setting gradient function.

---

    Code
      objective$set_hessian(f_hessian)
    Message
      → Setting Hessian function.

---

    Code
      objective$set_argument(a = 1)
    Message
      → Setting argument [34m[34m"a"[34m[39m.
      → Synchronized arguments with gradient function.
      → Synchronized arguments with Hessian function.

# objective with one target argument can be evaluated

    Code
      print(objective)
    Output
      * Function: f
      * Targets (length): x (1)
      * Fixed arguments: b, a

# objective with more than one target argument can be evaluated

    Code
      print(objective)
    Output
      * Function: llk
      * Targets (length): mu (2), sd (2), lambda (1)
      * Fixed arguments: data

# objective with NULL argument can be evaluated

    Code
      print(obj)
    Output
      * Function: f
      * Targets (length): x (3)
      * Fixed arguments: none

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/optimizer_dictionary.R
\docType{data}
\name{optimizer_dictionary}
\alias{optimizer_dictionary}
\title{Dictionary of optimizer functions}
\format{
An \code{R6} object of class \code{\link[oeli]{Dictionary}}.
}
\usage{
optimizer_dictionary
}
\description{
A dictionary of currently included numerical optimizer functions in the
\code{{optimizeR}} package.
}
\examples{
print(optimizer_dictionary)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/optimizer.R
\name{Optimizer}
\alias{Optimizer}
\title{Specify numerical optimizer object}
\description{
The \code{Optimizer} object defines a numerical optimizer based on any
optimization algorithm implemented in R. The main advantage of working with
an \code{Optimizer} object instead of using the optimization function
directly lies in the standardized inputs and outputs.

Any R function that fulfills the following four constraints can be defined
as an \code{Optimizer} object:
\enumerate{
\item It must have an input for a \code{function}, the objective function to be
optimized.
\item It must have an input for a \code{numeric} vector, the initial values
where the optimizer starts.
\item It must have a \code{...} argument for additional parameters passed on to
the objective function.
\item The output must be a named \code{list}, including the optimal function
value and the optimal parameter vector.
}
}
\examples{
### Task: compare minimization with 'stats::nlm' and 'pracma::nelder_mead'

# 1. define objective function and initial values
objective <- TestFunctions::TF_ackley
initial <- c(3, 3)

# 2. get overview of optimizers available in dictionary
optimizer_dictionary$keys

# 3. define 'nlm' optimizer
nlm <- Optimizer$new(which = "stats::nlm")

# 4. define the 'pracma::nelder_mead' optimizer
#    (not contained in the dictionary)
nelder_mead <- Optimizer$new(which = "custom")
nelder_mead$definition(
  algorithm = pracma::nelder_mead, # optimization function
  arg_objective = "fn",            # objective function argument name
  arg_initial = "x0",              # argument name for the initial values
  out_value = "fmin",              # element for the optimal function value
  out_parameter = "xmin",          # element for the optimal parameters
  direction = "min"                # optimizer minimizes
)

# 5. compare the minimization results
nlm$minimize(objective, initial)
nelder_mead$minimize(objective, initial)


## ------------------------------------------------
## Method `Optimizer$minimize`
## ------------------------------------------------

Optimizer$new("stats::nlm")$
  minimize(objective = function(x) x^4 + 3*x - 5, initial = 2)

## ------------------------------------------------
## Method `Optimizer$maximize`
## ------------------------------------------------

Optimizer$new("stats::nlm")$
  maximize(objective = function(x) -x^4 + 3*x - 5, initial = 2)

## ------------------------------------------------
## Method `Optimizer$optimize`
## ------------------------------------------------

objective <- function(x) -x^4 + 3*x - 5
optimizer <- Optimizer$new("stats::nlm")
optimizer$optimize(
  objective = objective, initial = 2, direction = "min"
)
optimizer$optimize(
  objective = objective, initial = 2, direction = "max"
)
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{label}}{[\code{character(1)}]\cr
The label for the optimizer.}

\item{\code{algorithm}}{[\code{function}]\cr
The optimization algorithm.}

\item{\code{arg_objective}}{[\code{character(1)}]\cr
The argument name for the objective function in \code{algorithm}.}

\item{\code{arg_initial}}{[\code{character(1)}]\cr
The argument name for the initial values in \code{algorithm}.}

\item{\code{arg_lower}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the lower parameter bound in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{arg_upper}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the upper parameter bound in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{arg_gradient}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the gradient function in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{arg_hessian}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the Hessian function in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{gradient_as_attribute}}{[\code{logical(1)}]\cr
Only relevant if \code{arg_gradient} is not \code{NA}.

In that case, does \code{algorithm} expect that the gradient is an attribute
of the objective function output (as for example in
\code{\link[stats]{nlm}})? In that case, \code{arg_gradient} defines the
attribute name.}

\item{\code{hessian_as_attribute}}{[\code{logical(1)}]\cr
Only relevant if \code{arg_hessian} is not \code{NA}.

In that case, does \code{algorithm} expect that the Hessian is an attribute
of the objective function output (as for example in
\code{\link[stats]{nlm}})? In that case, \code{arg_hessian} defines the
attribute name.}

\item{\code{out_value}}{[\code{character(1)}]\cr
The element name for the optimal function value in the output
\code{list} of \code{algorithm}.}

\item{\code{out_parameter}}{[\code{character(1)}]\cr
The element name for the optimal parameters in the output \code{list} of
\code{algorithm}.}

\item{\code{direction}}{[\code{character(1)}]\cr
Either \code{"min"} (if the optimizer minimizes) or \code{"max"}
(if the optimizer maximizes).}

\item{\code{arguments}}{[\code{list()}]\cr
Custom arguments for \code{algorithm}.

Defaults are used for arguments that are not specified.}

\item{\code{seconds}}{[\code{numeric(1)}]\cr
A time limit in seconds.

Optimization is interrupted prematurely if \code{seconds} is exceeded.

No time limit if \code{seconds = Inf} (the default).

Note the limitations documented in \code{\link[base]{setTimeLimit}}.}

\item{\code{hide_warnings}}{[\code{logical(1)}]\cr
Hide warnings during optimization?}

\item{\code{output_ignore}}{[\code{character()}]\cr
Elements to ignore (not include) in the optimization output.}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-Optimizer-new}{\code{Optimizer$new()}}
\item \href{#method-Optimizer-definition}{\code{Optimizer$definition()}}
\item \href{#method-Optimizer-set_arguments}{\code{Optimizer$set_arguments()}}
\item \href{#method-Optimizer-minimize}{\code{Optimizer$minimize()}}
\item \href{#method-Optimizer-maximize}{\code{Optimizer$maximize()}}
\item \href{#method-Optimizer-optimize}{\code{Optimizer$optimize()}}
\item \href{#method-Optimizer-print}{\code{Optimizer$print()}}
\item \href{#method-Optimizer-clone}{\code{Optimizer$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-new"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-new}{}}}
\subsection{Method \code{new()}}{
Initializes a new \code{Optimizer} object.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$new(which, ..., .verbose = TRUE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{which}}{[\code{character(1)}]\cr
Either:
\itemize{
\item one of \code{optimizer_dictionary$keys}
\item or \code{"custom"}, in which case \code{$definition()} must be used to
define the optimizer details.
}}

\item{\code{...}}{[\code{any}]\cr
In \code{Optimizer$new()} and \code{$set_arguments()}, named arguments to
pass to the optimizer algorithm. In \code{$minimize()},
\code{$maximize()}, and \code{$optimize()}, named arguments to pass to the
objective function.}

\item{\code{.verbose}}{[\code{logical(1)}]\cr
Print status messages?}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new \code{Optimizer} object.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-definition"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-definition}{}}}
\subsection{Method \code{definition()}}{
Defines an optimizer.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$definition(
  algorithm,
  arg_objective,
  arg_initial,
  arg_lower = NA,
  arg_upper = NA,
  arg_gradient = NA,
  arg_hessian = NA,
  gradient_as_attribute = FALSE,
  hessian_as_attribute = FALSE,
  out_value,
  out_parameter,
  direction
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{algorithm}}{[\code{function}]\cr
The optimization algorithm.}

\item{\code{arg_objective}}{[\code{character(1)}]\cr
The argument name for the objective function in \code{algorithm}.}

\item{\code{arg_initial}}{[\code{character(1)}]\cr
The argument name for the initial values in \code{algorithm}.}

\item{\code{arg_lower}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the lower parameter bound in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{arg_upper}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the upper parameter bound in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{arg_gradient}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the gradient function in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{arg_hessian}}{[\code{character(1)} | \code{NA}]\cr
Optionally the argument name for the Hessian function in
\code{algorithm}.

Can be \code{NA} if not available.}

\item{\code{gradient_as_attribute}}{[\code{logical(1)}]\cr
Only relevant if \code{arg_gradient} is not \code{NA}.

In that case, does \code{algorithm} expect that the gradient is an attribute
of the objective function output (as for example in
\code{\link[stats]{nlm}})? In that case, \code{arg_gradient} defines the
attribute name.}

\item{\code{hessian_as_attribute}}{[\code{logical(1)}]\cr
Only relevant if \code{arg_hessian} is not \code{NA}.

In that case, does \code{algorithm} expect that the Hessian is an attribute
of the objective function output (as for example in
\code{\link[stats]{nlm}})? In that case, \code{arg_hessian} defines the
attribute name.}

\item{\code{out_value}}{[\code{character(1)}]\cr
The element name for the optimal function value in the output
\code{list} of \code{algorithm}.}

\item{\code{out_parameter}}{[\code{character(1)}]\cr
The element name for the optimal parameters in the output \code{list} of
\code{algorithm}.}

\item{\code{direction}}{[\code{character(1)}]\cr
Either \code{"min"} (if the optimizer minimizes) or \code{"max"}
(if the optimizer maximizes).}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-set_arguments"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-set_arguments}{}}}
\subsection{Method \code{set_arguments()}}{
Sets optimizer arguments.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$set_arguments(...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{...}}{[\code{any}]\cr
In \code{Optimizer$new()} and \code{$set_arguments()}, named arguments to
pass to the optimizer algorithm. In \code{$minimize()},
\code{$maximize()}, and \code{$optimize()}, named arguments to pass to the
objective function.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
The \code{Optimizer} object.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-minimize"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-minimize}{}}}
\subsection{Method \code{minimize()}}{
Perform minimization.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$minimize(objective, initial, lower = NA, upper = NA, ...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{objective}}{[\code{function} | \code{Objective}]\cr
A \code{function} to be optimized that
\enumerate{
\item has at least one argument that receives a \code{numeric} \code{vector}
\item and returns a single \code{numeric} value.
}

Alternatively, it can also be an \code{\link{Objective}} object for more
flexibility.}

\item{\code{initial}}{[\code{numeric()}]\cr
Starting parameter values for the optimization.}

\item{\code{lower}}{[\code{NA} | \code{numeric()} | \code{numeric(1)}]\cr
Lower bounds on the parameters.

If a single number, this will be applied to all parameters.

Can be \code{NA} to not define any bounds.}

\item{\code{upper}}{[\code{NA} | \code{numeric()} | \code{numeric(1)}]\cr
Upper bounds on the parameters.

If a single number, this will be applied to all parameters.

Can be \code{NA} to not define any bounds.}

\item{\code{...}}{[\code{any}]\cr
In \code{Optimizer$new()} and \code{$set_arguments()}, named arguments to
pass to the optimizer algorithm. In \code{$minimize()},
\code{$maximize()}, and \code{$optimize()}, named arguments to pass to the
objective function.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A named \code{list}, containing at least these five elements:
\describe{
\item{\code{value}}{A \code{numeric}, the minimum function value.}
\item{\code{parameter}}{A \code{numeric} vector, the parameter vector
where the minimum is obtained.}
\item{\code{seconds}}{A \code{numeric}, the optimization time in
seconds.}
\item{\code{initial}}{A \code{numeric}, the initial parameter values.}
\item{\code{error}}{A \code{logical} flag: \code{TRUE} if an error
occurred, otherwise \code{FALSE}.}
}
Additional output elements from the optimizer are appended.

If an error occurred, the error message is also appended as element
\code{error_message}.

If the time limit was exceeded, this counts as an error. In addition,
the flag \code{time_out = TRUE} is appended.
}
\subsection{Examples}{
\if{html}{\out{<div class="r example copy">}}
\preformatted{Optimizer$new("stats::nlm")$
  minimize(objective = function(x) x^4 + 3*x - 5, initial = 2)
}
\if{html}{\out{</div>}}

}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-maximize"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-maximize}{}}}
\subsection{Method \code{maximize()}}{
Perform maximization.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$maximize(objective, initial, lower = NA, upper = NA, ...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{objective}}{[\code{function} | \code{Objective}]\cr
A \code{function} to be optimized that
\enumerate{
\item has at least one argument that receives a \code{numeric} \code{vector}
\item and returns a single \code{numeric} value.
}

Alternatively, it can also be an \code{\link{Objective}} object for more
flexibility.}

\item{\code{initial}}{[\code{numeric()}]\cr
Starting parameter values for the optimization.}

\item{\code{lower}}{[\code{NA} | \code{numeric()} | \code{numeric(1)}]\cr
Lower bounds on the parameters.

If a single number, this will be applied to all parameters.

Can be \code{NA} to not define any bounds.}

\item{\code{upper}}{[\code{NA} | \code{numeric()} | \code{numeric(1)}]\cr
Upper bounds on the parameters.

If a single number, this will be applied to all parameters.

Can be \code{NA} to not define any bounds.}

\item{\code{...}}{[\code{any}]\cr
In \code{Optimizer$new()} and \code{$set_arguments()}, named arguments to
pass to the optimizer algorithm. In \code{$minimize()},
\code{$maximize()}, and \code{$optimize()}, named arguments to pass to the
objective function.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A named \code{list}, containing at least these five elements:
\describe{
\item{\code{value}}{A \code{numeric}, the maximum function value.}
\item{\code{parameter}}{A \code{numeric} vector, the parameter vector
where the maximum is obtained.}
\item{\code{seconds}}{A \code{numeric}, the optimization time in
seconds.}
\item{\code{initial}}{A \code{numeric}, the initial parameter values.}
\item{\code{error}}{A \code{logical} flag: \code{TRUE} if an error
occurred, otherwise \code{FALSE}.}
}
Additional output elements from the optimizer are appended.

If an error occurred, the error message is also appended as element
\code{error_message}.

If the time limit was exceeded, this also counts as an error. In
addition, the flag \code{time_out = TRUE} is appended.
}
\subsection{Examples}{
\if{html}{\out{<div class="r example copy">}}
\preformatted{Optimizer$new("stats::nlm")$
  maximize(objective = function(x) -x^4 + 3*x - 5, initial = 2)
}
\if{html}{\out{</div>}}

}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-optimize"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-optimize}{}}}
\subsection{Method \code{optimize()}}{
Perform minimization or maximization.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$optimize(
  objective,
  initial,
  lower = NA,
  upper = NA,
  direction = "min",
  ...
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{objective}}{[\code{function} | \code{Objective}]\cr
A \code{function} to be optimized that
\enumerate{
\item has at least one argument that receives a \code{numeric} \code{vector}
\item and returns a single \code{numeric} value.
}

Alternatively, it can also be an \code{\link{Objective}} object for more
flexibility.}

\item{\code{initial}}{[\code{numeric()}]\cr
Starting parameter values for the optimization.}

\item{\code{lower}}{[\code{NA} | \code{numeric()} | \code{numeric(1)}]\cr
Lower bounds on the parameters.

If a single number, this will be applied to all parameters.

Can be \code{NA} to not define any bounds.}

\item{\code{upper}}{[\code{NA} | \code{numeric()} | \code{numeric(1)}]\cr
Upper bounds on the parameters.

If a single number, this will be applied to all parameters.

Can be \code{NA} to not define any bounds.}

\item{\code{direction}}{[\code{character(1)}]\cr
Either \code{"min"} for minimization or \code{"max"} for maximization.}

\item{\code{...}}{[\code{any}]\cr
In \code{Optimizer$new()} and \code{$set_arguments()}, named arguments to
pass to the optimizer algorithm. In \code{$minimize()},
\code{$maximize()}, and \code{$optimize()}, named arguments to pass to the
objective function.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A named \code{list}, containing at least these five elements:
\describe{
\item{\code{value}}{A \code{numeric}, the optimized function value.}
\item{\code{parameter}}{A \code{numeric} vector, the parameter vector
where the optimum is obtained.}
\item{\code{seconds}}{A \code{numeric}, the optimization time in
seconds.}
\item{\code{initial}}{A \code{numeric}, the initial parameter values.}
\item{\code{error}}{A \code{logical} flag: \code{TRUE} if an error
occurred, otherwise \code{FALSE}.}
}
Additional output elements from the optimizer are appended.

If an error occurred, the error message is also appended as element
\code{error_message}.

If the time limit was exceeded, this also counts as an error. In
addition, the flag \code{time_out = TRUE} is appended.
}
\subsection{Examples}{
\if{html}{\out{<div class="r example copy">}}
\preformatted{objective <- function(x) -x^4 + 3*x - 5
optimizer <- Optimizer$new("stats::nlm")
optimizer$optimize(
  objective = objective, initial = 2, direction = "min"
)
optimizer$optimize(
  objective = objective, initial = 2, direction = "max"
)
}
\if{html}{\out{</div>}}

}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-print"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-print}{}}}
\subsection{Method \code{print()}}{
Prints the optimizer label.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$print(...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{...}}{[\code{any}]\cr
In \code{Optimizer$new()} and \code{$set_arguments()}, named arguments to
pass to the optimizer algorithm. In \code{$minimize()},
\code{$maximize()}, and \code{$optimize()}, named arguments to pass to the
objective function.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
Invisibly the \code{Optimizer} object.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Optimizer-clone"></a>}}
\if{latex}{\out{\hypertarget{method-Optimizer-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Optimizer$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/optimizeR-package.R
\docType{package}
\name{optimizeR-package}
\alias{optimizeR}
\alias{optimizeR-package}
\title{optimizeR: Unified Framework for Numerical Optimizers}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

Provides a unified object-oriented framework for numerical optimizers in R. Supports minimization and maximization with any optimizer, optimization over more than one function argument, computation time measurement, and time limits for long optimization tasks.
}
\examples{
### Task: compare minimization with 'stats::nlm' and 'pracma::nelder_mead'

# 1. define objective function and initial values
objective <- TestFunctions::TF_ackley
initial <- c(3, 3)

# 2. get overview of optimizers available in dictionary
optimizer_dictionary$keys

# 3. define 'nlm' optimizer
nlm <- Optimizer$new(which = "stats::nlm")

# 4. define the 'pracma::nelder_mead' optimizer
#    (not contained in the dictionary)
nelder_mead <- Optimizer$new(which = "custom")
nelder_mead$definition(
  algorithm = pracma::nelder_mead, # optimization function
  arg_objective = "fn",            # objective function argument name
  arg_initial = "x0",              # argument name for the initial values
  out_value = "fmin",              # element for the optimal function value
  out_parameter = "xmin",          # element for the optimal parameters
  direction = "min"                # optimizer minimizes
)

# 5. compare the minimization results
nlm$minimize(objective, initial)
nelder_mead$minimize(objective, initial)


## ------------------------------------------------
## Method `Optimizer$minimize`
## ------------------------------------------------

Optimizer$new("stats::nlm")$
  minimize(objective = function(x) x^4 + 3*x - 5, initial = 2)

## ------------------------------------------------
## Method `Optimizer$maximize`
## ------------------------------------------------

Optimizer$new("stats::nlm")$
  maximize(objective = function(x) -x^4 + 3*x - 5, initial = 2)

## ------------------------------------------------
## Method `Optimizer$optimize`
## ------------------------------------------------

objective <- function(x) -x^4 + 3*x - 5
optimizer <- Optimizer$new("stats::nlm")
optimizer$optimize(
  objective = objective, initial = 2, direction = "min"
)
optimizer$optimize(
  objective = objective, initial = 2, direction = "max"
)
}
\seealso{
Useful links:
\itemize{
  \item \url{https://loelschlaeger.de/optimizeR/}
  \item Report bugs at \url{https://github.com/loelschlaeger/optimizeR/issues}
}

}
\author{
\strong{Maintainer}: Lennart Oelschläger \email{oelschlaeger.lennart@gmail.com} (\href{https://orcid.org/0000-0001-5421-9313}{ORCID})

Other contributors:
\itemize{
  \item Marius Ötting \email{marius.oetting@uni-bielefeld.de} (\href{https://orcid.org/0000-0002-9373-0365}{ORCID}) [contributor]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/objective.R
\name{Objective}
\alias{Objective}
\title{Specify objective function object}
\value{
An \code{Objective} object.
}
\description{
The \code{Objective} object specifies the framework for an objective
function for numerical optimization.
}
\examples{
### define log-likelihood function of Gaussian mixture model
llk <- function(mu, sd, lambda, data) {
  sd <- exp(sd)
  lambda <- plogis(lambda)
  cluster_1 <- lambda * dnorm(data, mu[1], sd[1])
  cluster_2 <- (1 - lambda) * dnorm(data, mu[2], sd[2])
  sum(log(cluster_1 + cluster_2))
}

### optimize over the first three arguments, the 'data' argument is constant
objective <- Objective$new(
  f = llk, target = c("mu", "sd", "lambda"), npar = c(2, 2, 1),
  data = faithful$eruptions
)

### evaluate at 1:5 (1:2 is passed to mu, 3:4 to sd, and 5 to lambda)
objective$evaluate(1:5)
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{objective_name}}{[\code{character(1)}]\cr
The label for the objective function.}

\item{\code{fixed_arguments}}{[\code{character()}, read-only]\cr
The name(s) of the fixed argument(s) (if any).}

\item{\code{seconds}}{[\code{numeric(1)}]\cr
A time limit in seconds. Computations are interrupted
prematurely if \code{seconds} is exceeded.

No time limit if \code{seconds = Inf} (the default).

Note the limitations documented in \code{\link[base]{setTimeLimit}}.}

\item{\code{hide_warnings}}{[\code{logical(1)}]\cr
Hide warnings when evaluating the objective function?}

\item{\code{verbose}}{[\code{logical(1)}]\cr
Print status messages?}

\item{\code{npar}}{[\code{integer()}, read-only]\cr
The length of each target argument.}

\item{\code{target}}{[\code{character()}, read-only]\cr
The argument name(s) to optimize.}

\item{\code{gradient_specified}}{[\code{logical(1)}, read-only]\cr
Whether a gradient function has been specified via \verb{$set_gradient()}.}

\item{\code{hessian_specified}}{[\code{logical(1)}, read-only]\cr
Whether a Hessian function has been specified via \verb{$set_hessian()}.}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-Objective-new}{\code{Objective$new()}}
\item \href{#method-Objective-set_argument}{\code{Objective$set_argument()}}
\item \href{#method-Objective-get_argument}{\code{Objective$get_argument()}}
\item \href{#method-Objective-remove_argument}{\code{Objective$remove_argument()}}
\item \href{#method-Objective-set_gradient}{\code{Objective$set_gradient()}}
\item \href{#method-Objective-set_hessian}{\code{Objective$set_hessian()}}
\item \href{#method-Objective-evaluate}{\code{Objective$evaluate()}}
\item \href{#method-Objective-evaluate_gradient}{\code{Objective$evaluate_gradient()}}
\item \href{#method-Objective-evaluate_gradient_numeric}{\code{Objective$evaluate_gradient_numeric()}}
\item \href{#method-Objective-evaluate_hessian}{\code{Objective$evaluate_hessian()}}
\item \href{#method-Objective-evaluate_hessian_numeric}{\code{Objective$evaluate_hessian_numeric()}}
\item \href{#method-Objective-print}{\code{Objective$print()}}
\item \href{#method-Objective-clone}{\code{Objective$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-new"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-new}{}}}
\subsection{Method \code{new()}}{
Creates a new \code{Objective} object.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$new(f, target = NULL, npar, ...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{f}}{[\code{function}]\cr
A \code{function} to be optimized.

It is expected that \code{f} has at least one \code{numeric} argument.

Also, the return value of \code{f} is expected to have the
structure \code{numeric(1)}, i.e. a single \code{numeric} value.}

\item{\code{target}}{[\code{character()}]\cr
The argument name(s) to optimize.

All target arguments must be \code{numeric}.

If \code{NULL} (default), the first function argument is selected.}

\item{\code{npar}}{[\code{integer()}]\cr
The length of each target argument, i.e., the length(s) of the
\code{numeric} \code{vector} argument(s) specified by \code{target}.}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-set_argument"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-set_argument}{}}}
\subsection{Method \code{set_argument()}}{
Set a function argument that remains fixed during optimization.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$set_argument(..., .overwrite = TRUE, .verbose = self$verbose)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}

\item{\code{.overwrite}}{[\code{logical(1)}]\cr
Overwrite existing values?}

\item{\code{.verbose}}{[\code{logical(1)}]\cr
Print status messages?}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-get_argument"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-get_argument}{}}}
\subsection{Method \code{get_argument()}}{
Get a fixed function argument.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$get_argument(argument_name, .verbose = self$verbose)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{argument_name}}{[\code{character(1)}]\cr
A function argument name.}

\item{\code{.verbose}}{[\code{logical(1)}]\cr
Print status messages?}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-remove_argument"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-remove_argument}{}}}
\subsection{Method \code{remove_argument()}}{
Remove a fixed function argument.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$remove_argument(argument_name, .verbose = self$verbose)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{argument_name}}{[\code{character(1)}]\cr
A function argument name.}

\item{\code{.verbose}}{[\code{logical(1)}]\cr
Print status messages?}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-set_gradient"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-set_gradient}{}}}
\subsection{Method \code{set_gradient()}}{
Set a gradient function.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$set_gradient(
  gradient,
  target = self$target,
  npar = self$npar,
  ...,
  .verbose = self$verbose
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{gradient}}{[\code{function}]\cr
A \code{function} that computes the gradient of the objective function
\code{f}.

It is expected that \code{gradient} has the same call as \code{f}, and
that \code{gradient} returns a \code{numeric} \code{vector} of length
\code{sum(self$npar)}.}

\item{\code{target}}{[\code{character()}]\cr
The argument name(s) to optimize.

All target arguments must be \code{numeric}.

If \code{NULL} (default), the first function argument is selected.}

\item{\code{npar}}{[\code{integer()}]\cr
The length of each target argument, i.e., the length(s) of the
\code{numeric} \code{vector} argument(s) specified by \code{target}.}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}

\item{\code{.verbose}}{[\code{logical(1)}]\cr
Print status messages?}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-set_hessian"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-set_hessian}{}}}
\subsection{Method \code{set_hessian()}}{
Set a Hessian function.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$set_hessian(
  hessian,
  target = self$target,
  npar = self$npar,
  ...,
  .verbose = self$verbose
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{hessian}}{[\code{function}]\cr
A \code{function} that computes the Hessian of the objective function
\code{f}.

It is expected that \code{hessian} has the same call as \code{f}, and
that \code{hessian} returns a \code{numeric} \code{matrix} of dimension
\code{sum(self$npar)} times \code{sum(self$npar)}.}

\item{\code{target}}{[\code{character()}]\cr
The argument name(s) to optimize.

All target arguments must be \code{numeric}.

If \code{NULL} (default), the first function argument is selected.}

\item{\code{npar}}{[\code{integer()}]\cr
The length of each target argument, i.e., the length(s) of the
\code{numeric} \code{vector} argument(s) specified by \code{target}.}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}

\item{\code{.verbose}}{[\code{logical(1)}]\cr
Print status messages?}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-evaluate"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-evaluate}{}}}
\subsection{Method \code{evaluate()}}{
Evaluate the objective function.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$evaluate(
  .at,
  .negate = FALSE,
  .gradient_as_attribute = FALSE,
  .gradient_attribute_name = "gradient",
  .gradient_numeric = FALSE,
  .hessian_as_attribute = FALSE,
  .hessian_attribute_name = "hessian",
  .hessian_numeric = FALSE,
  ...
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{.at}}{[\code{numeric()}]\cr
The values for the target argument(s), written in a single vector.

Must be of length \code{sum(self$npar)}.}

\item{\code{.negate}}{[\code{logical(1)}]\cr
Negate the function return value?}

\item{\code{.gradient_as_attribute}}{[\code{logical(1)}]\cr
Add the value of the gradient function as an attribute to the output?

The attribute name is defined via the \code{.gradient_attribute_name}
argument.

Ignored if \verb{$gradient_specified} and \code{.gradient_numeric} are \code{FALSE}.}

\item{\code{.gradient_attribute_name}}{[\code{character(1)}]\cr
Only relevant if \code{.gradient_as_attribute = TRUE}.

In that case, the attribute name for the gradient (if available).}

\item{\code{.gradient_numeric}}{[\code{logical(1)}]\cr
Calculate the gradient via the numerical approximation
\code{\link[numDeriv]{grad}}?}

\item{\code{.hessian_as_attribute}}{[\code{logical(1)}]\cr
Add the value of the Hessian function as an attribute to the output?

The attribute name is defined via the \code{.hessian_attribute_name}
argument.

Ignored if \verb{$hessian_specified} and \code{hessian_numeric} are \code{FALSE}.}

\item{\code{.hessian_attribute_name}}{[\code{character(1)}]\cr
Only relevant if \code{.hessian_as_attribute = TRUE}.

In that case, the attribute name for the Hessian (if available).}

\item{\code{.hessian_numeric}}{[\code{logical(1)}]\cr
Calculate the Hessian via the numerical approximation
\code{\link[numDeriv]{hessian}}?}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-evaluate_gradient"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-evaluate_gradient}{}}}
\subsection{Method \code{evaluate_gradient()}}{
Evaluate the gradient function.

Returns a \code{numeric} vector of \code{NA_real_} values if the
evaluation fails or returns an unexpected result.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$evaluate_gradient(.at, .negate = FALSE, ...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{.at}}{[\code{numeric()}]\cr
The values for the target argument(s), written in a single vector.

Must be of length \code{sum(self$npar)}.}

\item{\code{.negate}}{[\code{logical(1)}]\cr
Negate the function return value?}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-evaluate_gradient_numeric"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-evaluate_gradient_numeric}{}}}
\subsection{Method \code{evaluate_gradient_numeric()}}{
Evaluate the numerical gradient \code{\link[numDeriv]{grad}}.

Returns a \code{numeric} vector of \code{NA_real_} values if the
calculation fails or returns an unexpected result.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$evaluate_gradient_numeric(.at, .negate = FALSE, ...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{.at}}{[\code{numeric()}]\cr
The values for the target argument(s), written in a single vector.

Must be of length \code{sum(self$npar)}.}

\item{\code{.negate}}{[\code{logical(1)}]\cr
Negate the function return value?}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-evaluate_hessian"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-evaluate_hessian}{}}}
\subsection{Method \code{evaluate_hessian()}}{
Evaluate the Hessian function.

Returns an \code{NA_real_} value or matrix if the evaluation fails or
returns an unexpected result.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$evaluate_hessian(.at, .negate = FALSE, ...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{.at}}{[\code{numeric()}]\cr
The values for the target argument(s), written in a single vector.

Must be of length \code{sum(self$npar)}.}

\item{\code{.negate}}{[\code{logical(1)}]\cr
Negate the function return value?}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-evaluate_hessian_numeric"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-evaluate_hessian_numeric}{}}}
\subsection{Method \code{evaluate_hessian_numeric()}}{
Evaluate the numerical Hessian \code{\link[numDeriv]{hessian}}.

Returns an \code{NA_real_} matrix if the calculation fails or returns an
unexpected result.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$evaluate_hessian_numeric(.at, .negate = FALSE, ...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{.at}}{[\code{numeric()}]\cr
The values for the target argument(s), written in a single vector.

Must be of length \code{sum(self$npar)}.}

\item{\code{.negate}}{[\code{logical(1)}]\cr
Negate the function return value?}

\item{\code{...}}{Optionally additional function arguments that are fixed during the
optimization.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-print"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-print}{}}}
\subsection{Method \code{print()}}{
Print details of the \code{Objective} object.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$print()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Objective-clone"></a>}}
\if{latex}{\out{\hypertarget{method-Objective-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Objective$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parameter_spaces.R
\name{ParameterSpaces}
\alias{ParameterSpaces}
\title{Switch between parameter spaces}
\description{
The \code{ParameterSpaces} object manages two related parameter spaces:
\itemize{
\item the Optimization Space (for optimization)
\item the Interpretation Space (for easier interpretation).
}

In the Optimization Space, parameters are stored as a \code{numeric}
\code{vector}, the standard format for numerical optimizers.

In the Interpretation Space, parameters are stored as a \code{list} and can
take different formats (e.g., \code{matrix}).

Users can define transformation functions (not necessarily bijective) to
switch between these spaces via the \code{$o2i()} and \code{$i2o()} methods.
}
\examples{
### Log-likelihood function of two-class Gaussian mixture model with
### parameter vector `theta` that consists of
### - `mu`, mean vector of length 2
### - `sd`, standard deviation vector of length 2, must be positive
### - `lambda`, class probability of length 1, must be between 0 and 1

normal_mixture_llk <- function(theta, data) {
  mu <- theta[1:2]
  sd <- exp(theta[3:4])
  lambda <- plogis(theta[5])
  c1 <- lambda * dnorm(data, mu[1], sd[1])
  c2 <- (1 - lambda) * dnorm(data, mu[2], sd[2])
  sum(log(c1 + c2))
}

### define parameter spaces
### - `mu` needs no transformation
### - `sd` needs to be real in optimization space and positive in
###    interpretation space
### - `lambda` needs to be real and of length `1` in optimization space, and
###    a probability vector of length `2` in interpretation space

normal_mixture_spaces <- ParameterSpaces$
  new(
    parameter_names = c("mu", "sd", "lambda"),
    parameter_lengths_in_o_space = c(2, 2, 1)
  )$
  o2i(
    "mu" = function(x) x,
    "sd" = function(x) exp(x),
    "lambda" = function(x) c(plogis(x), 1 - plogis(x))
  )$
  i2o(
    "mu" = function(x) x,
    "sd" = function(x) log(x),
    "lambda" = function(x) qlogis(x[1])
  )

### switch between parameter spaces

par <- list(              # parameters in interpretation space
  "mu" = c(2, 4),
  "sd" = c(0.5, 1),
  "lambda" = c(0.4, 0.6)
)
(x <- normal_mixture_spaces$switch(par)) # switch to optimization space
normal_mixture_llk(
  theta = x, data = datasets::faithful$eruptions
)
normal_mixture_spaces$switch(x)          # switch back

}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-ParameterSpaces-new}{\code{ParameterSpaces$new()}}
\item \href{#method-ParameterSpaces-print}{\code{ParameterSpaces$print()}}
\item \href{#method-ParameterSpaces-switch}{\code{ParameterSpaces$switch()}}
\item \href{#method-ParameterSpaces-o2i}{\code{ParameterSpaces$o2i()}}
\item \href{#method-ParameterSpaces-i2o}{\code{ParameterSpaces$i2o()}}
\item \href{#method-ParameterSpaces-clone}{\code{ParameterSpaces$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ParameterSpaces-new"></a>}}
\if{latex}{\out{\hypertarget{method-ParameterSpaces-new}{}}}
\subsection{Method \code{new()}}{
Initializes a new \code{ParameterSpaces} object.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ParameterSpaces$new(parameter_names, parameter_lengths_in_o_space)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{parameter_names}}{[\code{character()}]\cr
Unique names for the parameters.}

\item{\code{parameter_lengths_in_o_space}}{[\code{integer()}]\cr
The length of each parameter in the optimization space.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new \code{ParameterSpaces} object.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ParameterSpaces-print"></a>}}
\if{latex}{\out{\hypertarget{method-ParameterSpaces-print}{}}}
\subsection{Method \code{print()}}{
Print an overview of the parameter spaces.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ParameterSpaces$print(show_transformer = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{show_transformer}}{[\code{logical(1)}]\cr
Show transformer functions in the output?}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ParameterSpaces-switch"></a>}}
\if{latex}{\out{\hypertarget{method-ParameterSpaces-switch}{}}}
\subsection{Method \code{switch()}}{
Switch between Optimization Space and Interpretation Space.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ParameterSpaces$switch(x, to = NULL)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{x}}{[\code{numeric()} | \code{list()}]\cr
The parameters, either as a \verb{numeric vector} (will be switched to
Interpretation Space), or as a \code{list()} (will be switched to
Optimization Space).}

\item{\code{to}}{[\code{character(1)} | \code{NULL}]\cr
Explicitly switch to a specific space, either
\itemize{
\item \code{"o"}: Optimization Space
\item \code{"i"}: Interpretation Space
}

If \code{NULL}, the function will switch to the other space.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ParameterSpaces-o2i"></a>}}
\if{latex}{\out{\hypertarget{method-ParameterSpaces-o2i}{}}}
\subsection{Method \code{o2i()}}{
Define transformation functions when switching from Optimization Space
to Interpretation Space.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ParameterSpaces$o2i(...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{...}}{[\code{function}]\cr
One or more transformation functions, named according to the parameters.

Transformers from Optimization Space to Interpretation Space (o2i)
\strong{must receive} a \code{numeric}. The default is the identity.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ParameterSpaces-i2o"></a>}}
\if{latex}{\out{\hypertarget{method-ParameterSpaces-i2o}{}}}
\subsection{Method \code{i2o()}}{
Define transformation functions when switching from Interpretation Space
to Optimization Space.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ParameterSpaces$i2o(...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{...}}{[\code{function}]\cr
One or more transformation functions, named according to the parameters.

Transformers from Interpretation Space to Optimization Space (i2o)
\strong{must return} a \code{numeric}. The default is \code{as.vector()}.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ParameterSpaces-clone"></a>}}
\if{latex}{\out{\hypertarget{method-ParameterSpaces-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ParameterSpaces$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}
